SystemOrganization addCategory: #'GT-Examples'!
SystemOrganization addCategory: 'GT-Examples-Announcements'!
SystemOrganization addCategory: 'GT-Examples-Core'!
SystemOrganization addCategory: 'GT-Examples-Exceptions'!
SystemOrganization addCategory: 'GT-Examples-Help'!
SystemOrganization addCategory: 'GT-Examples-Organization'!
SystemOrganization addCategory: 'GT-Examples-Runtime'!
SystemOrganization addCategory: 'GT-Examples-Subjects'!
SystemOrganization addCategory: 'GT-Examples-Testing'!

Trait named: #TGTExampleIcon
	uses: {}
	category: 'GT-Examples-Organization'!

!TGTExampleIcon methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 14:50'!
basicForm
	^ self subclassResponsibility! !

!TGTExampleIcon methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/19/2016 14:50'!
form
	^ self exists
		ifTrue: [ self basicForm ]
		ifFalse: [ nil ]! !

Trait named: #TGTExampleMethod
	uses: {}
	category: 'GT-Examples-Organization'!

!RPackageTag methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/28/2016 17:16'!
gtExamplesContained
	| examples |
	examples := OrderedCollection new.
	self package methods do: [ :method |
		examples addAll: method gtExamples ].
	^ examples! !

CommandLineHandler subclass: #GTExamplesCommandLineHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Testing'!

!GTExamplesCommandLineHandler class methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:02'!
commandName
	^ 'examples'! !

!GTExamplesCommandLineHandler class methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:01'!
description
	^ 'A command line example runner'! !

!GTExamplesCommandLineHandler methodsFor: 'activation' stamp: 'TudorGirba 5/13/2017 07:01'!
activate
	self activateHelp
		ifTrue: [  ^ self ].
	self runPackages.! !

!GTExamplesCommandLineHandler methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:01'!
addPackagesMatching: aString to: aSet
	| regex |
	
	[ regex := aString asRegex ] 
		on: Error do: [ ].
	regex ifNotNil: [ ^ self addPackagesMatchingRegex: regex to: aSet ].
	
	(aString includes: $*)
		ifTrue: [ ^ self addPackagesMatchingGlob: aString to: aSet ].
	
	"exact match, and just those who actually have classes inside (to avoid 
	 super-package duplications)"
	((RPackage organizer includesPackageNamed: aString) 
		and: [ (RPackage organizer packageNamed: aString) definedClasses notEmpty ])
		ifTrue: [ aSet add: aString ]! !

!GTExamplesCommandLineHandler methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:01'!
addPackagesMatchingGlob: aGlobString to: aSet
	RPackage organizer packageNames do: [ :packageName|
		(aGlobString match: packageName)
			ifTrue: [ aSet add: packageName ]]! !

!GTExamplesCommandLineHandler methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:01'!
addPackagesMatchingRegex: aRegex to: aSet
	RPackage organizer packageNames do: [ :packageName|
		(aRegex matches: packageName)
			ifTrue: [ aSet add: packageName ]]! !

!GTExamplesCommandLineHandler methodsFor: 'private' stamp: 'TudorGirba 5/13/2017 07:11'!
exampleReport
	(self hasOption: 'junit-xml-output') ifTrue: [ ^ GTExamplesHDReport ].
	^ self error: 'only works for now for junit for now'! !

!GTExamplesCommandLineHandler methodsFor: 'private' stamp: 'TudorGirba 5/13/2017 07:01'!
inform: aString
	self stdout 
		<< aString
		<< OSPlatform current lineEnding! !

!GTExamplesCommandLineHandler methodsFor: 'private' stamp: 'TudorGirba 5/13/2017 07:01'!
informResults: results
	self stdout 
		<< ('{1} run, {2} passes, {3} failures, {4} errors.'
			format: {
				results sum: #suiteTotal.
				results sum: #suitePassing.
				results sum: #suiteFailures.
				results sum: #suiteErrors })
		<< OSPlatform current lineEnding! !

!GTExamplesCommandLineHandler methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:01'!
packages
	| packages |
	packages := Set new.
	self arguments 
		reject: [ :arg| arg beginsWith: '-']
		thenDo: [ :arg| self addPackagesMatching: arg to: packages ].
	^ packages! !

!GTExamplesCommandLineHandler methodsFor: 'private' stamp: 'TudorGirba 5/13/2017 07:06'!
runPackages
	| packages results |
	
	packages := self packages.
	self inform: 'Running examples in ', packages size asString, ' packages'.
	results := (self exampleReport runPackages: self packages) select: #notNil.
				
	self informResults: results.
	(self hasOption: 'save') ifTrue: [ Smalltalk saveSession ].
	((self hasOption: 'fail-on-failure') 
		and: [ results anySatisfy: #hasFailuresOrErrors ])
		ifTrue: [^ self exitFailure: 'Tests do not pass!!' ].
	((self hasOption: 'fail-on-error') 
		and: [ results anySatisfy: #hasErrors ])
		ifTrue: [^ self exitFailure: 'Tests do not pass!!' ].
	
	Smalltalk snapshot: false andQuit: true.! !

!ExceptionSet methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 6/15/2015 16:56'!
copyWith: anException
	^ self class new 
		instVarNamed: #exceptions put: (exceptions copyWith: anException);
		yourself! !

!ExceptionSet methodsFor: '*GT-Examples-Core' stamp: 'AndreiChis 10/15/2015 00:15'!
copyWithAll: aCollection
	^ self class new 
		instVarNamed: #exceptions put: (exceptions copy
			addAll: aCollection;
			yourself);
		yourself! !

!ExceptionSet methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 9/6/2015 17:43'!
signaledBy: anException
	(anException isNil and: [ exceptions isEmptyOrNil not ]) ifTrue: [ 
		^ (GTExampleExpectedExceptionNotRaised new 
			expectedError: self;
			exception: anException;
			yourself) signal ].
	(anException notNil and: [ (exceptions includes: anException class) not ]) ifTrue: [ 
		^ (GTExampleUnexpectedExceptionRaised new
			unexpectedError: anException;
			yourself) signal ]! !

Object subclass: #GTExample
	uses: TGTExampleMethod
	instanceVariableNames: 'methodClass selector label description form exceptions subjects children properties after problems extensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Core'!

!GTExample commentStamp: 'TudorGirba 9/6/2015 11:03' prior: 0!
I represent the concept of an example.

I am constructed out of a method that returns an object. I hold the meta-information about that method and I know how to construct the concrete resulting object that is returned by the method. 

I can depend on other examples, and other examples can depend on me. When I depend on another example, the code that produces me uses the result of the other example to construct me.

The class for which I represent the example is called my subject.

The class that offers the method out of which I am constructed is the provider.

I also know how to handle possible exceptions, which makes me a great candidate for encoding assumptions that are otherwise expressed as classic tests.!

GTExample class
	uses: TGTExampleMethod classTrait
	instanceVariableNames: ''!

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 12:56'!
= anExample
	^ self class = anExample class 
		and: [ self methodClass = anExample methodClass 
			and: [ self selector = anExample selector ] ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:32'!
addChild: aGTDependency
	children add: aGTDependency! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:32'!
addExtension: anExtension
	extensions add: anExtension! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/11/2016 11:01'!
addProblem: aProblem
	problems add: aProblem! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:32'!
addSubject: aGTExampleSubject
	subjects add: aGTExampleSubject asGTExampleSubject! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 3/28/2016 20:44'!
after
	^ after! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
after: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by the given selector, to be performed after this example has run ~ similar but not identical to teardown of sunit'>
	
	after := self methodResolverClass resolve: GTExampleMethodAfter example: self selector: aSelector! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 4/10/2016 18:59'!
afterArguments
	self after ifNil: [ ^ #() ].
	^ self after arguments! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
afterClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by (aClassOrClassName >> aSelector), to be performed after this example has run ~ similar but not identical to teardown of sunit'>
	
	after := self methodResolverClass resolve: GTExampleMethodAfter example: self className: aClassOrClassName meta: false selector: aSelector! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
afterMetaClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'A method, implemented by (aClassOrClassName >> aSelector), to be performed after this example has run ~ similar but not identical to teardown of sunit'>
	
	after := self methodResolverClass resolve: GTExampleMethodAfter example: self className: aClassOrClassName meta: true selector: aSelector! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 8/24/2015 21:38'!
allDependencies
	| examples |
	examples := Set new.
	(self traverser
		action: [ :example | examples add: example ];
		yourself) value.
	^ examples! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 8/24/2015 21:35'!
allDependents
	| examples |
	examples := Set new.
	(self traverser reversed
		action: [ :example | examples add: example ];
		yourself) value.
	^ examples! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 8/24/2015 20:54'!
arguments
	^ children asArray! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:02'!
classNamed: aClassOrClassName
	self deprecated: 'use GTExampleClassResolver instead'.
	^ (self classResolverClass
		theClassName: aClassOrClassName;
		meta: false; " lucky guess "
		yourself) theClassDo: [ :class | class ] ifNone: [ nil ]! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:02'!
classNamed: aClassName do: aBlock
	self deprecated: 'use GTExampleClassResolver instead'.
	^ (self classResolverClass
		theClassName: aClassName;
		meta: false; " lucky guess "
		yourself) theClassDo: aBlock! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:02'!
classNamed: aClassName do: aBlock1 ifNone: aBlock2
	self deprecated: 'use GTExampleClassResolver instead'.
	(self classResolverClass
		theClassName: aClassName;
		meta: false; " lucky guess "
		yourself) theClassDo: aBlock1 ifNone: aBlock2! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 2/19/2017 16:02'!
classResolverClass
	^ GTExampleClassResolver! !

!GTExample methodsFor: 'actions' stamp: 'StefanReichhart 9/2/2015 22:19'!
debug
	^ self debugger result! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 9/6/2015 17:42'!
debugger
	^ GTExampleDebugger new 
		example: self;
		yourself! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 15:02'!
dependencies
	^ self arguments collect: [ :each | each gtExample ]! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 15:27'!
dependenciesOrArguments
	^ self arguments collect: [ :each | each gtExample ifNil: [ each ] ]! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:33'!
depends: aSelector
	self deprecated: 'use #dependsOn: instead'.
	self dependsOn: aSelector! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 1/29/2017 10:42'!
dependsAll: aString
	self deprecated: 'use #dependsOnAll: instead'.
	self dependsOnAll: aString! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 1/29/2017 10:42'!
dependsClass: aClassOrClassName selector: aSelector
	self deprecated: 'use #dependsOnClass:selector: instead'.
	self dependsOnClass: aClassOrClassName selector: aSelector! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
dependsOn: aSelector
	<gtExamplePragma>
	<description: 'This example depends on the example declared by the given selector. Any dependency will be performed before this example is performed. Order of declaration is important'>
	
	self addChild: (self methodResolverClass resolve: GTExampleMethod example: self selector: aSelector)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 1/29/2017 10:40'!
dependsOnAll: aString
	<gtExamplePragma>
	<description: 'This example depends on all given selectors found in the given string (list separated by  .,;). Any dependency will be performed before this example is performed. Order of declaration is important'>
	
	self substrings: aString do: [ :each | 
		self dependsOn: aString ]! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
dependsOnClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'This example depends on the example declared by the given class and selector. Any dependency will be performed before this example is performed. Order of declaration is important'>
	
	children add: (self methodResolverClass resolve: GTExampleMethod example: self className: aClassOrClassName meta: false selector: aSelector)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
dependsOnMetaClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'This example depends on the example declared by the given meta-class and selector. Any dependency will be performed before this example is performed. Order of declaration is important'>
	
	children add: (self methodResolverClass resolve: GTExampleMethod example: self className: aClassOrClassName meta: true selector: aSelector)! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/7/2015 17:39'!
description
	^ description! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/21/2016 18:40'!
description: aString
	<gtExamplePragma>
	<description: 'A full description of this example'>
	
	description := aString! !

!GTExample methodsFor: 'TODO' stamp: 'StefanReichhart 7/4/2016 19:39'!
directDependents
	<todo: 'better name -> #myDependents and #dependents is taken - wtf!!'>
	^ (GTExampleOrganizer instance examplesSelect: [ :each | each hasDependency: self ]) asSet asArray! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 9/6/2015 17:42'!
evaluator
	^ GTExampleEvaluator new 
		example: self;
		yourself! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/29/2015 10:58'!
exceptions
	^ exceptions! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 14:31'!
exists
	^ self methodClass includesSelector: self selector! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 14:47'!
form
	^ form! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 14:21'!
form: anIcon
	form := anIcon! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 3/28/2016 19:28'!
gtExample
	<gtExamplePragma>
	<description: 'This method is turned into a gtExample if provided'>
	
	^ self! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/3/2016 15:03'!
gtExample: anObject
	<toBeDeprecated: 'Please define your example-label (or description) using the pragma #label: or #description:'>
	self label: anObject.
	self gtExample! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 15:19'!
gtExamplesContained
	^ { self }! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 15:02'!
gtExamplesFactory
	^ self method gtExamplesFactory! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:09'!
hasAfter
	^ after notNil! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 17:48'!
hasAfter: anAfterMethod
	^ after = anAfterMethod! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:09'!
hasAfterArguments
	^ self hasAfter
		and: [ self after hasArguments ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:06'!
hasArguments
	^ self arguments notEmpty! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:04'!
hasDependencies
	^ self arguments notEmpty! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 18:24'!
hasDependency: aGTExample
	^ self arguments anySatisfy: [ :each | each matchesMethod: aGTExample ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 16:45'!
hasDependent: anExample
	^ self directDependents anySatisfy: [ :each | each matchesExample: anExample ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 16:45'!
hasDependents
	^ self directDependents notEmpty! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/21/2016 13:58'!
hasExtensions
	^ extensions isEmptyOrNil not! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2016 18:21'!
hasInternalProblems
	^ problems notEmpty! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/28/2016 15:16'!
hasLiteralThorough: aLiteral
	^ self methodClass = aLiteral
		or: [ self selector = aLiteral
			or: [ (self label notNil and: [ self label includesSubstring: aLiteral asString caseSensitive: false ])
				or: [ (self description notNil and: [ self description includesSubstring: aLiteral asString caseSensitive: false ])
					or: [ (self subjects anySatisfy: [ :each | each hasLiteralThorough: aLiteral ])
						or: [ self exists and: [ (self method hasLiteralThorough: aLiteral asSymbol) or: [ self method hasLiteralThorough: aLiteral asSymbol ] ] ] ] ] ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 18:45'!
hasProblems
	^ problems notEmpty
		or: [ self hasValidArguments not
			or: [  self hasValidAfter not
				or: [ self hasValidDependencies not ] ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 9/21/2015 20:33'!
hasRelationships
	^ self hasDependents
		or: [ self hasDependencies ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 20:20'!
hasSubject: aSubject
	^ self subjects anySatisfy: [ :each | 
		each == aSubject 
			or: [ each = aSubject ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/6/2016 22:05'!
hasSubjectMatching: aStringOrSubject
	^ (self hasSubject: aStringOrSubject)
		or: [ self subjects anySatisfy: [ :each | 
			each hasLiteralThorough: aStringOrSubject ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:26'!
hasSubjects
	^ self subjects notEmpty! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 18:46'!
hasValidAfter
	^ self hasAfter not
		or: [ self after isValid ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:07'!
hasValidArguments
	^ self arguments size = self method numArgs! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 20:32'!
hasValidDependencies
	^ self hasValidArguments 
		and: [ self hasDependencies not
			or: [ self dependencies allSatisfy: [ :each | 
				each notNil and: [ each exists ] ] ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/21/2016 14:39'!
hasValidExtensions
	^ self hasExtensions not
		or: [ extensions allSatisfy: [ :each | 
				each notNil and: [ each isValid ] ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 12:56'!
hash
	^ (self class hash 
		bitXor: self methodClass hash) 
			bitXor: self selector hash! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:21'!
icon
	^ form ifNotNil: [ form form ]! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/19/2016 15:04'!
icon: aSelector
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The selector must be implemented by the currently active theme'>

	self iconThemeSelector: aSelector! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 16:26'!
iconBase64: aString
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The icon form is described by the given base64-encoded string'>
	
	form := GTExampleFormIcon fromBase64String: aString! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 16:26'!
iconBytes: aByteArray
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The icon form is described by the given byte-array'>
	
	form := GTExampleFormIcon fromByteArray: aByteArray! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
iconClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The method described by the given class and selector must return an icon form'>
	
	form := self methodResolverClass resolve: GTExampleMethodIcon example: self className: aClassOrClassName meta: false selector: aSelector! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
iconMetaClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The method described by the given meta-class and selector must return an icon form'>
	
	form := self methodResolverClass resolve: GTExampleMethodIcon example: self className: aClassOrClassName meta: true selector: aSelector! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
iconSelector: aSelector
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The selector must return an icon form'>
	
	form := (self methodResolverClass resolve: GTExampleMethodIcon example: self selector: aSelector)
		converter: #convertFromByteArray:;
		yourself! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
iconSelectorBase64: aSelector
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The icon form is described by the base64 string returned by the given selector'>
	
	form := (self methodResolverClass resolve: GTExampleMethodIcon example: self selector: aSelector)
		converter: #convertFromBase64String:;
		yourself! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 16:28'!
iconThemeSelector: aSelector
	<gtExamplePragma>
	<description: 'Attach an icon to this example. The selector must be implemented by the currently active theme'>
	
	form := GTExampleThemeIcon fromSelector: aSelector! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 9/26/2015 10:59'!
ignoreTest
	^ self propertyAt: #noTest ifAbsent: [ false ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 4/24/2016 17:16'!
ignoreTestReport
	^ self propertyAt: #noTestReport ifAbsent: [ false ]! !

!GTExample methodsFor: 'initializing' stamp: 'StefanReichhart 7/21/2016 14:46'!
initialize
	super initialize.
	
	children := OrderedCollection new.
	subjects := Set new.
	problems := Set new.
	exceptions := ExceptionSet new.	
	properties := IdentityDictionary new.
	extensions := Set new.! !

!GTExample methodsFor: 'initializing' stamp: 'StefanReichhart 7/11/2016 09:40'!
initializeFromMethod: aCompiledMethod usingFactory: aGTExampleFactory
	methodClass := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	aGTExampleFactory initializeExample: self fromMethod: aCompiledMethod! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/4/2016 20:44'!
invalidArguments
	^ self arguments reject: [ :each | each isValid ]! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/14/2016 18:10'!
invalidDependencies
	^ self arguments reject: [ :each | each isValid or: [ each exists ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 17:57'!
isGTExample
	^ true! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 8/28/2016 15:01'!
isReferencing: aLiteral
	^ (self hasSubject: aLiteral)
		or: [ (self subjects anySatisfy: [ :subject | subject hasLiteralThorough: aLiteral ])
			or: [ (self exists and: [ self method hasLiteralThorough: aLiteral ])
				or: [ (self methodClass name asString = aLiteral asString) ] ] ]! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 22:53'!
isValid
	^ self hasProblems not
		and: [ self traverser canProcess ]! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 6/7/2015 17:39'!
label
	^ label! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/21/2016 18:39'!
label: aString
	<gtExamplePragma>
	<description: 'A short identifier = name of this example'>
	
	label := aString! !

!GTExample methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 14:30'!
matchesMethod: aCompiledMethod
	^ aCompiledMethod class = CompiledMethod
		and: [ self methodClass = aCompiledMethod methodClass
			and: [ self selector = aCompiledMethod selector ] ]! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 12:34'!
method
	^ self methodClass >> self selector! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:02'!
method: aMethodClass forClass: aClass named: aClassName selector: aSelector
	self deprecated: 'use GTExampleMethodResolver instead'.
	^ self methodResolverClass resolve: aMethodClass example: self className: (aClass ifNotNil: [ aClass name ] ifNil: [ aClassName ]) meta: (aClass ifNotNil: [ aClass isMeta ] ifNil: [ false " lucky guess " ]) selector: aSelector! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:33'!
method: aGTExampleMethodClass forClass: aClass selector: aSelector
	self deprecated: 'use GTExampleMethodResolver instead'.
	^ self methodResolverClass resolve: aGTExampleMethodClass example: self className: aClass meta: aClass isMeta selector: aSelector! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:02'!
method: aMethodClass forClassNamed: aClassOrClassName selector: aSelector
	self deprecated: 'use GTExampleMethodResolver instead'.
	^ self methodResolverClass resolve: aMethodClass example: self className: aClassOrClassName meta: false " lucky guess " selector: aSelector! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 1/29/2017 13:37'!
method: aMethodClass forSelector: aSelector
	self deprecated: 'use GTExampleMethodResolver instead'.
	self method: aMethodClass forClass: self methodClass selector: aSelector
	! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/14/2016 18:16'!
methodArgumentNames
	^ self exists
		ifTrue: [ self method argumentNames ]
		ifFalse: [ #() ]! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 12:27'!
methodClass
	^ methodClass! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 15:19'!
methodReference
	^ self method asRingDefinition! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 2/19/2017 16:02'!
methodResolverClass
	^ GTExampleMethodResolver! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 3/28/2016 19:26'!
noTest
	<gtExamplePragma>
	<description: 'Do not run this example while running SUnit tests'>
	
	self propertyAt: #noTest put: true! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 4/24/2016 17:17'!
noTestReport
	<gtExamplePragma>
	<description: 'Do not run this example while running HDTestReport (not yet implemented)'>
	
	self propertyAt: #noTestReport put: true! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 10:58'!
problems
	" some problems are static -> #problems / other problems are dynamic (and changing) and not stored in #problems -> arguments+examples "
	^ (problems , self invalidArguments) asArray! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 09:43'!
propertyAt: aKey
	^ properties at: aKey! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 09:43'!
propertyAt: aKey ifAbsent: aBlock
	^ properties at: aKey ifAbsent: aBlock! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 09:43'!
propertyAt: aKey ifAbsentPut: aBlock
	^ properties at: aKey ifAbsentPut: aBlock! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 09:43'!
propertyAt: aKey put: aValue
	^ properties at: aKey put: aValue! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 12:54'!
provider 
	^ self methodClass isMeta
		ifTrue: [ self methodClass theNonMetaClass ]
		ifFalse: [ self methodClass theNonMetaClass new ]! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
raises: aClassOrClassName
	<gtExamplePragma>
	<description: 'This example is expected to raise the given exception. The example (as a test) will fail if the exception is not raised.'>
	(self classResolverClass new
		theClassName: aClassOrClassName;
		meta: false;
		yourself) theClassDo: [ :class | self exceptions add: class ]! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/21/2016 18:37'!
raisesAny: aString
	<gtExamplePragma>
	<description: 'This example is expected to raise any of the given exceptions (list separated by  .,;). The example (as a test) will fail if none of the exceptions is raised.'>
	
	self substrings: aString do: [ :each | 
		self raises: each ]! !

!GTExample methodsFor: 'initializing' stamp: 'StefanReichhart 7/11/2016 17:22'!
reinitialize
	| method |
	(method := self method) ifNil: [ ^ self ].
	
	self initialize.
	method gtExamplesFactory initializeExample: self fromMethod: method! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/3/2016 19:05'!
result
	^ self run! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 8/2/2015 12:00'!
returnValue
	^ self result returnValue! !

!GTExample methodsFor: 'actions' stamp: 'StefanReichhart 7/2/2016 21:55'!
run
	^ self evaluator result ! !

!GTExample methodsFor: 'actions' stamp: 'StefanReichhart 7/6/2016 13:27'!
runThenDo: aBlock1 onErrorDo: aBlock2
	| result |
	^ (result := self run) isSuccess 
		ifTrue: [ aBlock1 value: result ]
		ifFalse: [ aBlock2 value: result ]! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 12:27'!
selector
	^ selector! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 5/13/2016 11:02'!
signalableExceptions
	^ self exceptions copyWithAll: { Halt. Error. Exit. UnhandledError. TestFailure. Deprecation. }! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 9/6/2015 18:37'!
sourceCode
	^ self method sourceCode! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/19/2016 15:05'!
subject: aClassOrClassName
	<gtExamplePragma>
	<description: 'Add a class-subject to the example'>
	
	self subjectClass: aClassOrClassName! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
subjectClass: aClassOrClassName
	<gtExamplePragma>
	<description: 'Add a class-subject to the example'>
	
	self addSubject: (self classResolverClass resolve: GTExampleClassSubject example: self className: aClassOrClassName meta: false)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
subjectClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'Add a method-subject to the example'>
	
	self addSubject: (self methodResolverClass resolve: GTExampleMethodSubject example: self className: aClassOrClassName meta: false selector: aSelector)! !

!GTExample methodsFor: 'DEPRECATED' stamp: 'StefanReichhart 2/19/2017 16:02'!
subjectForClassNamed: aClassName
	self deprecated: 'use GTExampleClassResolver instead'.
	^ (self classResolverClass
		theClassName: aClassName;
		meta: false; " lucky guess "
		yourself) theClassDo: [ :class | class ] ifNone: [ nil ]! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/21/2016 18:38'!
subjectHelp: bookName
	<gtExamplePragma>
	<description: 'Add a help/topic-subject to the example'>
	
	self subjectHelp: bookName title: nil! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 15:59'!
subjectHelp: bookName title: title
	<gtExamplePragma>
	<description: 'Add a help/topic-subject to the example'>
	
	self addSubject: (GTExampleHelpSubject fromBook: bookName title: title)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 15:45'!
subjectKeyword: aStringOrSymbol
	<gtExamplePragma>
	<description: 'Add a keyword to the example'>
	
	self addSubject: (GTExampleKeywordSubject fromString: aStringOrSymbol)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 12:21'!
subjectKeywords: anArrayOrString
	<gtExamplePragma>
	<description: 'Add multiple keywords to the example'>
	
	anArrayOrString gtExampleSubstrings do: [ :each |
		self subjectKeyword: each ]! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
subjectMetaClass: aClassOrClassName
	<gtExamplePragma>
	<description: 'Add a meta-class-subject to the example'>
	
	self addSubject: (self classResolverClass resolve: GTExampleClassSubject example: self className: aClassOrClassName meta: true)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 2/19/2017 16:02'!
subjectMetaClass: aClassOrClassName selector: aSelector
	<gtExamplePragma>
	<description: 'Add a method-subject to the example'>
	
	self addSubject: (self methodResolverClass resolve: GTExampleMethodSubject example: self className: aClassOrClassName meta: true selector: aSelector)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 16:02'!
subjectPackage: packageName
	<gtExamplePragma>
	<description: 'Add a package-subject to the example'>
	
	self addSubject: (GTExamplePackageSubject fromPackageNamed: packageName)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 15:44'!
subjectSelector: aSelector
	<gtExamplePragma>
	<description: 'Add a selector subject to the example'>
	
	self addSubject: (GTExampleSelectorSubject fromString: aSelector)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 16:04'!
subjectTag: tagName
	<gtExamplePragma>
	<description: 'Add a tag-subject to the example'>
	
	self addSubject: (GTExampleTagSubject fromTagNamed: tagName)! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 8/13/2016 15:43'!
subjectText: aString
	<gtExamplePragma>
	<description: 'Add a text-subject to the example'>
	
	self addSubject: (GTExampleTextSubject fromText: aString)! !

!GTExample methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 10:58'!
subjects
	^ subjects asArray! !

!GTExample methodsFor: 'PRAGMA-SELECTORS' stamp: 'StefanReichhart 7/21/2016 18:38'!
subjectsAll: aString
	<gtExamplePragma>
	<description: 'Add multiple class-subjects (list separated by  .,;) to the example'>
	
	self substrings: aString do: [ :each | 
		self subject: each ]! !

!GTExample methodsFor: 'private' stamp: 'StefanReichhart 8/13/2016 12:22'!
substrings: aString do: aBlock
	aString gtExampleSubstrings do: [ :each | 
		aBlock value: each ]! !

!GTExample methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 9/6/2015 17:42'!
traverser
	^ GTExampleTraverser new 
		example: self;
		yourself! !

Object subclass: #GTExampleAspect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

GTExampleAspect subclass: #GTAbstractExampleMethod
	uses: TGTExampleMethod
	instanceVariableNames: 'methodClassName methodClass meta selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

GTAbstractExampleMethod class
	uses: TGTExampleMethod classTrait
	instanceVariableNames: ''!

!GTAbstractExampleMethod class methodsFor: 'instance creation' stamp: 'StefanReichhart 1/29/2017 13:21'!
fromClass: aClass selector: aSelector
	^ self new 
		methodClass: aClass;
		methodClassName: aClass name;
		meta: aClass isMeta;
		selector: aSelector;
		yourself! !

!GTAbstractExampleMethod class methodsFor: 'instance creation' stamp: 'StefanReichhart 1/29/2017 13:22'!
fromClassNamed: aString selector: aSelector
	^ self new 
		methodClass: nil;
		methodClassName: aString asString;
		meta: false;
		selector: aSelector;
		yourself! !

!GTAbstractExampleMethod class methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 15:47'!
isAbstract
	^ self == GTAbstractExampleMethod! !

!GTAbstractExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:43'!
= anExampleMethod
	^ self class = anExampleMethod class 
		and: [ self methodClassName = anExampleMethod methodClassName 
			and: [ self selector = anExampleMethod selector ] ]! !

!GTAbstractExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 13:38'!
exists
	^ self methodClassName notNil
		and: [ self methodClass notNil
			and: [ self methodClass includesSelector: self selector ] ]! !

!GTAbstractExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 15:57'!
hasLiteralThorough: aLiteral
	^ self methodClassName = aLiteral 
		or: [ self selector = aLiteral
			or: [ self exists 
				and: [ self method hasLiteralThorough: aLiteral ] ] ]! !

!GTAbstractExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:43'!
hash
	^ (self class hash 
		bitXor: self methodClassName hash)
			bitXor: self selector hash! !

!GTAbstractExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 13:38'!
matchesMethod: aCompiledMethod
	^ self exists
		and: [ self methodClass = aCompiledMethod methodClass
			and: [ self selector = aCompiledMethod selector ] ]! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 10:56'!
meta
	^ meta ifNil: [ meta := false ]! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 10:53'!
meta: anObject
	meta := anObject! !

!GTAbstractExampleMethod methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/11/2016 15:22'!
method
	^ self exists 
		ifTrue: [ self methodClass >> self selector ]
		ifFalse: [ nil ]! !

!GTAbstractExampleMethod methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/14/2016 18:16'!
methodArgumentNames
	^ self exists
		ifTrue: [ self method argumentNames ]
		ifFalse: [ #() ]! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:42'!
methodClass
	^ methodClass ifNil: [ methodClass := self resolveMethodClass ]
		! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:24'!
methodClass: anObject
	methodClass := anObject! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:24'!
methodClassName
	^ methodClassName! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:24'!
methodClassName: anObject
	methodClassName := anObject! !

!GTAbstractExampleMethod methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 13:26'!
methodClassResolver
	^ GTExampleMethodResolver new 
		methodClassName: self methodClassName;
		meta: self meta;
		selector: self selector;
		yourself! !

!GTAbstractExampleMethod methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 8/19/2016 21:38'!
provider 
	self exists ifFalse: [ ^ nil ].
	^ self methodClass isMeta
		ifTrue: [ self methodClass theNonMetaClass ]
		ifFalse: [ self methodClass theNonMetaClass new ]! !

!GTAbstractExampleMethod methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:34'!
resetStub
	" 1) reset -> 2) reinitialize  "
	methodClass := nil! !

!GTAbstractExampleMethod methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 13:27'!
resolveMethodClass
	" an aspect might reference a class not being present in the system - it has to be resolved again in this case "
	^ self methodClassResolver methodClassDo: [ :class | class ] ifNone: [ nil ]! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:24'!
selector
	^ selector! !

!GTAbstractExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:24'!
selector: anObject
	selector := anObject! !

GTAbstractExampleMethod subclass: #GTExampleMethod
	instanceVariableNames: 'arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 13:23'!
arguments
	^ arguments ifNil: [ #() ]! !

!GTExampleMethod methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 13:23'!
arguments: anObject
	arguments := anObject! !

!GTExampleMethod methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 8/13/2016 16:10'!
asGTExampleSubject
	^ GTExampleMethodSubject fromClass: self methodClass selector: self selector! !

!GTExampleMethod methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/19/2016 13:01'!
gtExample
	^ self hasExample 
		ifTrue: [ self method gtExample ]
		ifFalse: [ nil ]! !

!GTExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 00:13'!
hasArguments
	^ self arguments notEmpty! !

!GTExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/19/2016 13:02'!
hasExample
	^ self exists
		and: [ self method isGTExampleMethod ]! !

!GTExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 15:07'!
hasValidArguments
	^ self exists 
		and: [ self arguments size = self method numArgs ]! !

!GTExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 20:40'!
isValid
	^ super isValid 
		and: [ self hasValidArguments ]! !

!GTExampleMethod methodsFor: 'testing' stamp: 'StefanReichhart 7/19/2016 13:02'!
matchesExample: aGTExample
	^ self exists 
		and: [ aGTExample isGTExample
			and: [ aGTExample methodClass = self methodClass
				and: [ aGTExample selector = self selector ] ] ]! !

GTAbstractExampleMethod subclass: #GTExampleMethodAfter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

GTAbstractExampleMethod subclass: #GTExampleMethodIcon
	uses: TGTExampleIcon
	instanceVariableNames: 'converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

GTExampleMethodIcon class
	uses: TGTExampleIcon classTrait
	instanceVariableNames: ''!

!GTExampleMethodIcon class methodsFor: 'converters' stamp: 'StefanReichhart 8/13/2016 16:30'!
convertFromBase64String: aString
	^ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: aString readStream)! !

!GTExampleMethodIcon class methodsFor: 'converters' stamp: 'StefanReichhart 8/13/2016 16:30'!
convertFromByteArray: aByteArray
	^ self convertFromByteArray: aByteArray extent: 16@16 depth: 32 offset: 0@0! !

!GTExampleMethodIcon class methodsFor: 'converters' stamp: 'StefanReichhart 8/13/2016 16:30'!
convertFromByteArray: aByteArray extent: anExtent depth: aDepth offset: anOffset
	^ Form
		extent: anExtent
		depth: aDepth
		fromArray: aByteArray 
		offset: anOffset! !

!GTExampleMethodIcon methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 13:46'!
basicForm
	^ self class 
		perform: self converter 
		withArguments: { self provider perform: self selector }! !

!GTExampleMethodIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:37'!
converter
	^ converter! !

!GTExampleMethodIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:37'!
converter: anObject
	converter := anObject! !

!GTExampleMethodIcon methodsFor: 'testing' stamp: 'StefanReichhart 8/19/2016 11:39'!
exists
	^ super exists
		and: [ self converter notNil
			and: [ self class class includesSelector: self converter ] ]! !

!GTExampleMethodIcon methodsFor: 'accessing-dynamic' stamp: ''!
form
	^ self exists
		ifTrue: [ self basicForm ]
		ifFalse: [ nil ]! !

GTAbstractExampleMethod subclass: #GTExampleMethodSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleMethodSubject commentStamp: 'TudorGirba 8/21/2016 21:46' prior: 0!
I describe a method subject of an example. I should be a subclas of GTExampleSubject, but for now I am external because it seems I have more in common in terms of implementation to GTExampleMethod.!

!GTExampleMethodSubject methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/4/2016 13:25'!
asGTExampleSubject
	^ self! !

!GTExampleAspect class methodsFor: 'testing' stamp: 'TudorGirba 8/20/2016 00:29'!
isAbstract
	^ self == GTExampleAspect! !

!GTExampleAspect methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 16:00'!
exists
	^ false! !

!GTExampleAspect methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 15:44'!
hasLiteralThorough: aLiteral
	^ false! !

!GTExampleAspect methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 15:47'!
isAbstract
	^ self class isAbstract! !

!GTExampleAspect methodsFor: 'testing' stamp: 'StefanReichhart 7/15/2016 20:07'!
isValid
	^ self exists! !

!GTExampleAspect methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:34'!
resetStub! !

GTExampleAspect subclass: #GTExampleIcon
	uses: TGTExampleIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

GTExampleIcon class
	uses: TGTExampleIcon classTrait
	instanceVariableNames: ''!

GTExampleIcon subclass: #GTExampleFormIcon
	instanceVariableNames: 'arguments converter form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleFormIcon class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/19/2016 11:28'!
fromBase64String: aString
	^ self new
		converter: #convertFromBase64String:;
		arguments: { aString };
		yourself! !

!GTExampleFormIcon class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/19/2016 11:28'!
fromByteArray: aByteArray
	^ self new
		converter: #convertFromByteArray:;
		arguments: { aByteArray };
		yourself! !

!GTExampleFormIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:24'!
arguments
	^ arguments! !

!GTExampleFormIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:24'!
arguments: anObject
	arguments := anObject! !

!GTExampleFormIcon methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 13:45'!
basicForm
	^ [ GTExampleMethodIcon 
		perform: self converter 
		withArguments: self arguments ] on: Error do: [ nil ]! !

!GTExampleFormIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:24'!
converter
	^ converter! !

!GTExampleFormIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:24'!
converter: anObject
	converter := anObject! !

!GTExampleFormIcon methodsFor: 'testing' stamp: 'StefanReichhart 7/19/2016 14:39'!
exists
	^ self converter notNil
		and: [ (GTExampleMethodIcon includesSelector: self converter)
			and: [ self form notNil ] ]! !

!GTExampleFormIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 13:45'!
form
	^ form ifNil: [ form := self basicForm ]! !

!GTExampleIcon class methodsFor: 'testing' stamp: 'TudorGirba 8/20/2016 00:29'!
isAbstract
	^ self == GTExampleIcon! !

!GTExampleIcon methodsFor: 'private' stamp: ''!
basicForm
	^ self subclassResponsibility! !

!GTExampleIcon methodsFor: 'accessing-dynamic' stamp: ''!
form
	^ self exists
		ifTrue: [ self basicForm ]
		ifFalse: [ nil ]! !

GTExampleIcon subclass: #GTExampleThemeIcon
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleThemeIcon class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:27'!
fromSelector: aSelector
	^ self new 
		selector: aSelector;
		yourself! !

!GTExampleThemeIcon class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:27'!
fromString: aString
	^ self fromSelector: aString asSymbol! !

!GTExampleThemeIcon methodsFor: 'private' stamp: 'StefanReichhart 7/19/2016 14:34'!
basicForm
	^ Smalltalk ui icons iconNamed: self selector ! !

!GTExampleThemeIcon methodsFor: 'testing' stamp: 'StefanReichhart 7/19/2016 14:34'!
exists
	^ (Smalltalk ui icons iconNamed: self selector ifNone: [ nil ]) notNil! !

!GTExampleThemeIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:24'!
selector
	^ selector! !

!GTExampleThemeIcon methodsFor: 'accessing' stamp: 'StefanReichhart 7/19/2016 14:24'!
selector: anObject
	selector := anObject! !

GTExampleAspect subclass: #GTExampleSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleSubject commentStamp: 'TudorGirba 8/20/2016 00:27' prior: 0!
I am the abstract of a description of a subject of an example. The concrete subclasses encapsulate the links to the concrete subjects.

For example, the goal of an example might be to exemplify the way an instance of a class X can look like. In this case,  the subject is the class X. Or, the goal of the example might be to instantiate class X and in this case, the subject can be the instantiating method.

The subject information is useful both when understanding the goal of an example, and to link examples to the static entities. For example, if a class has examples associated, these can appear in the static code browser, or in the inspector of the class.!

GTExampleSubject subclass: #GTExampleClassSubject
	instanceVariableNames: 'theClassName theClass meta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleClassSubject commentStamp: 'TudorGirba 8/21/2016 21:47' prior: 0!
I describe a class subject of an example.!

!GTExampleClassSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 1/29/2017 13:23'!
fromClass: aClass
	^ self new 
		theClass: aClass;
		theClassName: aClass name;
		meta: aClass isMeta;
		yourself! !

!GTExampleClassSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 1/29/2017 13:23'!
fromClassNamed: aString
	^ self new 
		theClass: nil;
		theClassName: aString asString;
		meta: false;
		yourself! !

!GTExampleClassSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 1/29/2017 13:24'!
fromMetaClassNamed: aString
	^ self new 
		theClass: nil;
		theClassName: aString asString;
		meta: true;
		yourself! !

!GTExampleClassSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:48'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self theClassName = anExampleSubject theClassName ]! !

!GTExampleClassSubject methodsFor: 'private' stamp: 'StefanReichhart 2/19/2017 16:02'!
classResolverClass
	^ GTExampleClassResolver new 
		theClassName: self theClassName;
		meta: self meta;
		yourself! !

!GTExampleClassSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 14:01'!
exists
	^ self theClass notNil! !

!GTExampleClassSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/28/2016 16:45'!
hasLiteralThorough: aLiteral
	^ self theClassName = aLiteral
		or: [ self exists 
			and: [ self theClass = aLiteral ] ]! !

!GTExampleClassSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:46'!
hash
	^ self class hash
		bitXor: self theClassName hash! !

!GTExampleClassSubject methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 13:13'!
meta
	^ meta! !

!GTExampleClassSubject methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 13:13'!
meta: anObject
	meta := anObject! !

!GTExampleClassSubject methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:34'!
resetStub
	" 1) reset -> 2) reinitialize "
	theClass := nil! !

!GTExampleClassSubject methodsFor: 'private' stamp: 'StefanReichhart 2/19/2017 16:02'!
resolveClass
	" an aspect might reference a class not being present in the system - it has to be resolved again in this case "
	^ self classResolverClass theClassDo: [ :class | class ] ifNone: [ nil ]! !

!GTExampleClassSubject methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 13:13'!
theClass
	^ theClass ifNil: [ theClass := self resolveClass ]
		! !

!GTExampleClassSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/22/2016 12:42'!
theClass: anObject
	anObject ifNotNil: [ self theClassName: anObject name ].
	theClass := anObject.
	! !

!GTExampleClassSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:30'!
theClassName
	^ theClassName! !

!GTExampleClassSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:30'!
theClassName: anObject
	theClassName := anObject! !

GTExampleClassSubject subclass: #GTExampleSubclassesSubject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleSubclassesSubject methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/22/2016 12:35'!
gtExamplesContained
	| subjects |
	subjects := self theSubclasses collect: [ :each | each asGTExampleSubject ].
	^ Smalltalk gtExamplesContained select: [ :each | 
		(each hasSubject: self)
			or: [ subjects anySatisfy: [ :subject | each hasSubject: subject ] ] ]! !

!GTExampleSubclassesSubject methodsFor: 'converting' stamp: 'StefanReichhart 7/22/2016 12:36'!
gtExamplesSubjects
	^ super gtExamplesSubjects , (self theSubclasses collect: [ :each | each asGTExampleSubject ])! !

!GTExampleSubclassesSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/22/2016 12:32'!
hasLiteralThorough: aLiteral
	^ (super hasLiteralThorough: aLiteral)
		or: [ self theSubclasses anySatisfy: [ :class | 
				class asGTExampleSubject hasLiteralThorough: aLiteral ] ]! !

!GTExampleSubclassesSubject methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/22/2016 12:32'!
theSubclasses
	^ self exists 
		ifFalse: [ {  } ]
		ifTrue: [ self theClass allSubclasses ]! !

GTExampleSubject subclass: #GTExampleHelpSubject
	instanceVariableNames: 'bookName title topic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleHelpSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:59'!
fromBook: aString
	^ self fromBook: aString title: nil! !

!GTExampleHelpSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:55'!
fromBook: aString1 title: aString2
	^ self new 
		bookName: aString1;
		title: aString2;
		yourself! !

!GTExampleHelpSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:58'!
fromTopic: aHelpTopic
	^ self fromBook: aHelpTopic title title: (aHelpTopic subtopics 
		ifNotEmpty: [ :topics | topics first title ]
		ifEmpty: [ nil ])! !

!GTExampleHelpSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:39'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self bookName = anExampleSubject bookName 
			and: [ self title = anExampleSubject title ] ]! !

!GTExampleHelpSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 14:22'!
bookName
	^ bookName! !

!GTExampleHelpSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 14:22'!
bookName: anObject
	bookName := anObject! !

!GTExampleHelpSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 14:08'!
exists
	^ self topic notNil! !

!GTExampleHelpSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 14:21'!
hasLiteralThorough: aLiteral
	^ self topic notNil 
		and: [ self topic contents notNil
			and: [ self topic contents includesSubstring: aLiteral asString caseSensitive: false ] ]! !

!GTExampleHelpSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:39'!
hash
	^ (self class hash
		bitXor: self bookName hash)
			bitXor: self title hash! !

!GTExampleHelpSubject methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:34'!
resetStub
	topic := nil.! !

!GTExampleHelpSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 14:06'!
title
	^ title! !

!GTExampleHelpSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 14:06'!
title: anObject
	title := anObject! !

!GTExampleHelpSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/21/2016 17:28'!
topic
	topic ifNil: [ 
		CustomHelp withAllSubclassesDo: [ :class | 
			class asHelpTopic ifNotNil: [ :help |
				(help title = bookName
						and: [ title isNil 
							or: [ help subtopics anySatisfy: [ :subhelp | 
									subhelp title = title ] ] ]) ifTrue: [ 
					topic := help ] ] ] ].
	^ topic! !

!GTExampleHelpSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 14:07'!
topic: anObject
	topic := anObject! !

GTExampleSubject subclass: #GTExampleInstanceSubject
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleInstanceSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:00'!
fromObject: anObject
	^ self new 
		instance: anObject;
		yourself! !

!GTExampleInstanceSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:39'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self instance = anExampleSubject instance ]! !

!GTExampleInstanceSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 13:41'!
exists
	^ self theClass notNil! !

!GTExampleInstanceSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 16:11'!
hasLiteralThorough: aLiteral
	^ self exists
		and: [ self theClass methods anySatisfy: [ :method | 
			method selector = aLiteral
				or: [ 	method hasLiteralThorough: aLiteral ] ] ]! !

!GTExampleInstanceSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:39'!
hash
	^ self class hash
		bitXor: self instance hash! !

!GTExampleInstanceSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/2/2016 19:42'!
instance
	^ instance! !

!GTExampleInstanceSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/2/2016 19:42'!
instance: anObject
	instance := anObject! !

!GTExampleInstanceSubject methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/4/2016 13:41'!
theClass
	^ self instance class! !

GTExampleSubject subclass: #GTExampleKeywordSubject
	instanceVariableNames: 'keyword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleKeywordSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:45'!
fromString: aString
	^ self new 
		keyword: aString;
		yourself! !

!GTExampleKeywordSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:47'!
fromSymbol: aSymbol
	^ self new 
		keyword: aSymbol;
		yourself! !

!GTExampleKeywordSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:47'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self keyword = anExampleSubject keyword ]! !

!GTExampleKeywordSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:08'!
exists
	^ true! !

!GTExampleKeywordSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:19'!
hasLiteralThorough: aLiteral
	^ self keyword = aLiteral
		or: [ self keyword asString asLowercase = aLiteral asString asLowercase ]! !

!GTExampleKeywordSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:47'!
hash
	^ self class hash
		bitXor: self keyword hash! !

!GTExampleKeywordSubject methodsFor: 'accessing' stamp: 'StefanReichhart 8/13/2016 12:18'!
keyword
	^ keyword! !

!GTExampleKeywordSubject methodsFor: 'accessing' stamp: 'StefanReichhart 8/13/2016 12:18'!
keyword: anObject
	keyword := anObject! !

GTExampleSubject subclass: #GTExamplePackageSubject
	instanceVariableNames: 'thePackageName thePackage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExamplePackageSubject commentStamp: 'TudorGirba 8/21/2016 21:47' prior: 0!
I describe a package subject of an example.!

!GTExamplePackageSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:02'!
fromPackage: aRPackage
	^ self new 
		thePackage: aRPackage;
		thePackageName: aRPackage packageName;
		yourself! !

!GTExamplePackageSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:02'!
fromPackageNamed: aString
	^ self new 
		thePackage: nil;
		thePackageName: aString asString;
		yourself! !

!GTExamplePackageSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:39'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self thePackageName = anExampleSubject thePackageName ]! !

!GTExamplePackageSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 13:56'!
exists
	^ self thePackage notNil! !

!GTExamplePackageSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/28/2016 16:45'!
hasLiteralThorough: aLiteral
	^ self thePackageName = aLiteral! !

!GTExamplePackageSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 18:39'!
hash
	^ self class hash
		bitXor: self thePackageName hash! !

!GTExamplePackageSubject methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:34'!
resetStub
	thePackage := nil! !

!GTExamplePackageSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/21/2016 17:30'!
thePackage
	^ thePackage ifNil: [ thePackage := RPackageOrganizer default packages 
		detect: [ :each | each packageName = thePackageName ]
		ifNone: [ nil ] ]! !

!GTExamplePackageSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/22/2016 12:42'!
thePackage: anObject
	anObject ifNotNil: [ self thePackageName: anObject packageName ].
	thePackage := anObject! !

!GTExamplePackageSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:50'!
thePackageName
	^ thePackageName! !

!GTExamplePackageSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:50'!
thePackageName: anObject
	thePackageName := anObject! !

GTExampleSubject subclass: #GTExampleSelectorSubject
	instanceVariableNames: 'selector theClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleSelectorSubject commentStamp: 'TudorGirba 8/21/2016 21:49' prior: 0!
I describe a selector as a subject of an example.!

!GTExampleSelectorSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:42'!
fromString: aString
	^ self fromSymbol: aString asSymbol! !

!GTExampleSelectorSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:42'!
fromSymbol: aSymbol
	^ self new
		selector: aSymbol;
		yourself! !

!GTExampleSelectorSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:46'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self selector = anExampleSubject selector ]! !

!GTExampleSelectorSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:41'!
exists
	^ self theClasses isEmptyOrNil not! !

!GTExampleSelectorSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:42'!
hasLiteralThorough: aLiteral
	^ self selector = aLiteral
		or: [ self theClasses anySatisfy: [ :class |
			(class >> self selector) asGTExampleSubject hasLiteralThorough: aLiteral ] ]! !

!GTExampleSelectorSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:47'!
hash
	^ self class hash
		bitXor: self selector hash! !

!GTExampleSelectorSubject methodsFor: 'private' stamp: 'StefanReichhart 8/13/2016 12:38'!
resetStub
	theClasses := nil! !

!GTExampleSelectorSubject methodsFor: 'accessing' stamp: 'StefanReichhart 8/13/2016 12:35'!
selector
	^ selector! !

!GTExampleSelectorSubject methodsFor: 'accessing' stamp: 'StefanReichhart 8/13/2016 12:35'!
selector: anObject
	selector := anObject! !

!GTExampleSelectorSubject methodsFor: 'private' stamp: 'StefanReichhart 8/13/2016 12:40'!
theClasses
	theClasses ifNil: [ 
		theClasses := Array streamContents: [ :stream |
			Smalltalk allClassesAndTraitsDo: [ :class |
				(class includesSelector: self selector) ifTrue: [ 
					stream nextPut: class ] ] ] ].
	^ theClasses! !

!GTExampleSubject class methodsFor: 'testing' stamp: 'TudorGirba 8/21/2016 07:43'!
isAbstract
	^ self == GTExampleSubject! !

!GTExampleSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:48'!
= anExampleSubject
	^ self subclassResponsibility! !

!GTExampleSubject methodsFor: 'converting' stamp: 'StefanReichhart 7/2/2016 19:45'!
asGTExampleSubject
	^ self! !

!GTExampleSubject methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/22/2016 12:02'!
gtExamplesContained
	^ Smalltalk gtExamplesContained select: [ :each | each hasSubject: self ]! !

!GTExampleSubject methodsFor: 'converting' stamp: 'StefanReichhart 7/22/2016 12:35'!
gtExamplesSubjects
	^ { self }! !

!GTExampleSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:48'!
hash
	^ self subclassResponsibility! !

GTExampleSubject subclass: #GTExampleTagSubject
	instanceVariableNames: 'theTagName theTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleTagSubject commentStamp: 'TudorGirba 8/21/2016 21:48' prior: 0!
I describe a package tag subject of an example.!

!GTExampleTagSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:03'!
fromTag: aRPackageTag
	^ self new 
		theTag: aRPackageTag;
		theTagName: aRPackageTag categoryName;
		yourself! !

!GTExampleTagSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 16:04'!
fromTagNamed: aString
	^ self new 
		theTag: nil;
		theTagName: aString asString;
		yourself! !

!GTExampleTagSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:48'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self theTagName = anExampleSubject theTagName ]! !

!GTExampleTagSubject methodsFor: 'testing' stamp: 'StefanReichhart 7/4/2016 14:45'!
exists
	^ self theTag notNil! !

!GTExampleTagSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/28/2016 16:45'!
hasLiteralThorough: aLiteral
	^ self theTagName = aLiteral
		or: [ self exists
			and: [ self theTag categoryName = aLiteral ] ]! !

!GTExampleTagSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:48'!
hash
	^ self class hash
		bitXor: self theTagName hash! !

!GTExampleTagSubject methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:34'!
resetStub
	theTag := nil! !

!GTExampleTagSubject methodsFor: 'accessing-dynamic' stamp: 'StefanReichhart 7/11/2016 16:44'!
thePackage
	^ self theTag package! !

!GTExampleTagSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/21/2016 17:31'!
theTag
	theTag ifNil: [ 
		RPackageOrganizer default packages do: [ :package |
			package classTags do: [ :tag | 
				(tag name = theTagName
					or: [ tag categoryName = theTagName ]) ifTrue: [ 
						^ theTag := tag ] ] ] ].
	^ theTag! !

!GTExampleTagSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/22/2016 12:43'!
theTag: anObject
	anObject ifNotNil: [ self theTagName: anObject name ].
	theTag := anObject! !

!GTExampleTagSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:59'!
theTagName
	^ theTagName! !

!GTExampleTagSubject methodsFor: 'accessing' stamp: 'StefanReichhart 7/4/2016 13:59'!
theTagName: anObject
	theTagName := anObject! !

GTExampleSubject subclass: #GTExampleTextSubject
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Subjects'!

!GTExampleTextSubject commentStamp: 'TudorGirba 8/21/2016 21:48' prior: 0!
I describe a plain text as a subject of an example.!

!GTExampleTextSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:43'!
fromString: aString
	^ self new 
		text: aString;
		yourself! !

!GTExampleTextSubject class methodsFor: 'instance creation' stamp: 'StefanReichhart 8/13/2016 15:43'!
fromText: aText
	^ self fromString: aText asString! !

!GTExampleTextSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:48'!
= anExampleSubject
	^ self class = anExampleSubject class
		and: [ self text = anExampleSubject text ]! !

!GTExampleTextSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 11:54'!
exists
	^ true! !

!GTExampleTextSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 11:55'!
hasLiteralThorough: aLiteral
	^ self text = aLiteral
		or: [ self text includesSubstring: aLiteral asString caseSensitive: false ]! !

!GTExampleTextSubject methodsFor: 'testing' stamp: 'StefanReichhart 8/13/2016 12:48'!
hash
	^ self class hash
		bitXor: self text hash! !

!GTExampleTextSubject methodsFor: 'accessing' stamp: 'StefanReichhart 8/13/2016 11:53'!
text
	^ text! !

!GTExampleTextSubject methodsFor: 'accessing' stamp: 'StefanReichhart 8/13/2016 11:53'!
text: anObject
	text := anObject! !

Object subclass: #GTExampleAspectResolver
	instanceVariableNames: 'example meta aspectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleAspectResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:46'!
aspectClass
	^ aspectClass! !

!GTExampleAspectResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:46'!
aspectClass: anObject
	aspectClass := anObject! !

!GTExampleAspectResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:56'!
ensureClass: aClass
	(aClass isMeta not and: [ self meta ]) 
		ifTrue: [ ^ aClass class " be nice " ].
	(aClass isMeta and: [ self meta not ]) 
		ifTrue: [ ^ aClass "backward compatibility " ].
	" default case "
	^ aClass! !

!GTExampleAspectResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:06'!
example
	^ example! !

!GTExampleAspectResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:06'!
example: anObject
	example := anObject! !

!GTExampleAspectResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:06'!
meta
	^ meta! !

!GTExampleAspectResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 12:06'!
meta: anObject
	meta := anObject! !

GTExampleAspectResolver subclass: #GTExampleClassResolver
	instanceVariableNames: 'theClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleClassResolver class methodsFor: 'actions' stamp: 'StefanReichhart 1/29/2017 13:06'!
resolve: anAspectClass example: anExample className: aClassOrString meta: meta
	^ (self new 
		aspectClass: anAspectClass;
		example: anExample;
		theClassName: aClassOrString;
		meta: meta;
		yourself) resolve! !

!GTExampleClassResolver methodsFor: 'actions' stamp: 'StefanReichhart 1/29/2017 12:37'!
resolve
	^ self theClassDo: [ :class | self resolveByClass: class ]
		ifNone: [ self resolveByName ]! !

!GTExampleClassResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:46'!
resolveByClass: aClass
	^ self aspectClass new
		theClass: aClass;
		theClassName: aClass name;
		meta: aClass isMeta;
		yourself! !

!GTExampleClassResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 13:05'!
resolveByName
	^ self aspectClass new
		theClass: nil;
		theClassName: self theClassName;
		meta: self meta;
		yourself! !

!GTExampleClassResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 13:06'!
theClass
	^ self theClassName isClass 
		ifTrue: [ self theClassName ]
		ifFalse: [ Smalltalk classNamed: self theClassName asString ]! !

!GTExampleClassResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 13:06'!
theClassDo: aBlock
	^ self theClassDo: aBlock ifNone: [ 
		(GTExampleDeclaredClassMissing new
			example: self example;
			classNamed: self theClassName;
			meta: self meta;
			yourself) signal ]! !

!GTExampleClassResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:38'!
theClassDo: aBlock1 ifNone: aBlock2
	^ self theClass
		ifNotNil: [ :class | aBlock1 value: (self ensureClass: class) ]
		ifNil: aBlock2
	! !

!GTExampleClassResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 13:05'!
theClassName
	^ theClassName! !

!GTExampleClassResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 13:05'!
theClassName: anObject
	theClassName := anObject! !

GTExampleAspectResolver subclass: #GTExampleMethodResolver
	instanceVariableNames: 'methodClass methodClassName selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleMethodResolver class methodsFor: 'actions' stamp: 'StefanReichhart 1/29/2017 12:47'!
resolve: anAspectClass example: anExample className: aClassOrString meta: meta selector: aStringOrSelector
	^ (self new 
		aspectClass: anAspectClass;
		example: anExample;
		methodClassName: aClassOrString;
		meta: meta;
		selector: aStringOrSelector;
		yourself) resolve! !

!GTExampleMethodResolver class methodsFor: 'actions' stamp: 'StefanReichhart 1/29/2017 12:47'!
resolve: anAspectClass example: anExample selector: aStringOrSelector
	^ (self new 
		aspectClass: anAspectClass;
		example: anExample;
		methodClassName: anExample methodClass;
		meta: anExample methodClass isMeta;
		selector: aStringOrSelector;
		yourself) resolve! !

!GTExampleMethodResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:10'!
methodClass
	^ self methodClassName isClass 
		ifTrue: [ self methodClassName ]
		ifFalse: [ Smalltalk classNamed: self methodClassName asString ]! !

!GTExampleMethodResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:14'!
methodClassDo: aBlock
	^ self methodClassDo: aBlock ifNone: [ 
		(GTExampleDeclaredClassMissing new
			example: self example;
			classNamed: self methodClassName;
			meta: self meta;
			yourself) signal ]! !

!GTExampleMethodResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:39'!
methodClassDo: aBlock1 ifNone: aBlock2
	^ self methodClass
		ifNotNil: [ :class | aBlock1 value: (self ensureClass: class) ]
		ifNil: aBlock2
	! !

!GTExampleMethodResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 11:16'!
methodClassName
	^ methodClassName! !

!GTExampleMethodResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 11:16'!
methodClassName: anObject
	methodClassName := anObject! !

!GTExampleMethodResolver methodsFor: 'actions' stamp: 'StefanReichhart 1/29/2017 12:37'!
resolve
	^ self methodClassDo: [ :class | self resolveByClass: class ] 
		ifNone: [ self resolveByName ]! !

!GTExampleMethodResolver methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 12:46'!
resolveByClass: aClass
	^ self aspectClass new
		methodClass: aClass;
		methodClassName: aClass name;
		meta: aClass isMeta;
		selector: self selector asSymbol;
		yourself! !

!GTExampleMethodResolver methodsFor: 'private' stamp: 'StefanReichhart 2/18/2017 19:12'!
resolveByName
	^ self aspectClass new
		methodClass: nil;
		methodClassName: self methodClassName asSymbol;
		meta: self meta;
		selector: self selector asSymbol;
		yourself! !

!GTExampleMethodResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 11:16'!
selector
	^ selector! !

!GTExampleMethodResolver methodsFor: 'accessing' stamp: 'StefanReichhart 1/29/2017 11:16'!
selector: anObject
	selector := anObject! !

Object subclass: #GTExampleFactory
	instanceVariableNames: 'cache source provider exampleClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

!GTExampleFactory commentStamp: 'TudorGirba 8/22/2016 14:33' prior: 0!
I am an internal factory for creating concrete instances of various classes, such as: example,  provider etc.!

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
cache
	^ cache ifNil: [ cache := self defaultCache ]! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
cache: anObject
	^ cache := anObject! !

!GTExampleFactory methodsFor: 'private-utils' stamp: 'StefanReichhart 2/19/2017 16:32'!
createExample: aCompiledMethod
	| newExample |
	newExample := self exampleClass new.
	[ newExample initializeFromMethod: aCompiledMethod usingFactory: self ]
		on: Deprecation
		do: [ :exception | 
			newExample addProblem: (GTExampleDeprecationDetected new
				example: newExample;
				signaledException: exception; 
				yourself).
			exception resume ].
	^ newExample! !

!GTExampleFactory methodsFor: 'accessing-defaults' stamp: 'TudorGirba 8/20/2016 00:39'!
defaultCache
	^ GTExampleOrganizer instance! !

!GTExampleFactory methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 7/2/2016 19:16'!
defaultExampleClass
	^ GTExample! !

!GTExampleFactory methodsFor: 'accessing-defaults' stamp: 'TudorGirba 8/20/2016 00:39'!
defaultProviderFor: aCompiledMethod 
	^ aCompiledMethod methodClass isMeta
		ifTrue: [ aCompiledMethod methodClass theNonMetaClass ]
		ifFalse: [ aCompiledMethod methodClass theNonMetaClass new " WARNING: not all classes support this -> override this using: #provider: " ] ! !

!GTExampleFactory methodsFor: 'private' stamp: 'TudorGirba 8/20/2016 00:40'!
exampleAt: aCompiledMethod ifAbsentPut: aBlock
	^ aBlock value! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
exampleClass
	^ exampleClass ifNil: [ exampleClass := self defaultExampleClass ]! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
exampleClass: anObject
	exampleClass := anObject! !

!GTExampleFactory methodsFor: 'private' stamp: 'TudorGirba 8/20/2016 00:40'!
exampleFromMethod: aCompiledMethod do: aBlock
	aBlock value: (self cache exampleAt: aCompiledMethod ifAbsentPut: [ self createExample: aCompiledMethod ])! !

!GTExampleFactory methodsFor: 'private' stamp: 'TudorGirba 8/20/2016 00:40'!
exampleMethod: aCompiledMethod do: aBlock
	(self isExampleMethod: aCompiledMethod) ifFalse: [ ^ self ].
	self exampleFromMethod: aCompiledMethod do: aBlock! !

!GTExampleFactory methodsFor: 'private' stamp: 'TudorGirba 8/20/2016 00:40'!
exampleMethodsDo: aBlock
	self source theNonMetaClass methods
		select: [ :each | self isExampleMethod: each ]
		thenDo: aBlock.
	self source theMetaClass methods
		select: [ :each | self isExampleMethod: each ]
		thenDo: aBlock.
		! !

!GTExampleFactory methodsFor: 'private' stamp: 'TudorGirba 8/20/2016 00:40'!
examplesDo: aBlock
	self exampleMethodsDo: [ :method |
		self exampleFromMethod: method do: aBlock ]! !

!GTExampleFactory methodsFor: 'public' stamp: 'TudorGirba 8/20/2016 00:40'!
gtExamplesContained
	| examples |
	examples := OrderedCollection new.
	self examplesDo: [ :example | examples add: example ].
	^ examples! !

!GTExampleFactory methodsFor: 'private - creating examples' stamp: 'TudorGirba 8/21/2016 07:12'!
initializeExample: aGTExample fromMethod: aCompiledMethod
	self initializeSubjectsForMethod: aCompiledMethod forExample: aGTExample.
	self initializePragmasFromMethod: aCompiledMethod forExample: aGTExample.
! !

!GTExampleFactory methodsFor: 'private-init' stamp: 'TudorGirba 8/20/2016 00:40'!
initializePragmas: aCollection forExample: aGTExample
	aCollection do: [ :pragma | 
		(aGTExample class canPerform: pragma keyword) ifTrue: [ 
			[ aGTExample perform: pragma keyword withArguments: pragma arguments ]
				on:Error
				do:[ :exception | 
					aGTExample addProblem: (GTExamplePragmaError new 
						example: aGTExample;
						pragma: pragma;
						signaledException: exception;
						yourself) ] ] ]! !

!GTExampleFactory methodsFor: 'private-init' stamp: 'TudorGirba 8/20/2016 00:40'!
initializePragmasFromMethod: aCompiledMethod forExample: aGTExample
	self initializePragmas: aCompiledMethod pragmas forExample: aGTExample! !

!GTExampleFactory methodsFor: 'private-init' stamp: 'TudorGirba 8/20/2016 00:40'!
initializeSubjects: aCollection forExample: aGTExample
	aCollection isEmptyOrNil ifTrue: [ ^ self ].
	
	aCollection do: [ :subject | 
		[ aGTExample addSubject: subject ]
			on:Error
			do: [ :exception | 
				aGTExample addProblem: (GTExampleSubjectError new 
					example: aGTExample;
					subject: subject;
					signaledException: exception;
					yourself) ] ] ! !

!GTExampleFactory methodsFor: 'private-init' stamp: 'TudorGirba 8/20/2016 00:40'!
initializeSubjectsForMethod: aCompiledMethod forExample: aGTExample
	[ self providerFor: aCompiledMethod do: [ :each | 
			(each class canPerform: #gtExamplesSubjects) ifTrue: [
				self initializeSubjects: each gtExamplesSubjects forExample: aGTExample ] ] ]
		on: Error
		do: [ :exception | 
			aGTExample addProblem: (GTExampleSubjectError new 
				example: aGTExample;
				signaledException: exception;
				yourself) ]! !

!GTExampleFactory methodsFor: 'testing' stamp: 'StefanReichhart 7/2/2016 20:00'!
isExampleMethod: aCompiledMethod
	^ self isGTExampleMethod: aCompiledMethod ! !

!GTExampleFactory methodsFor: 'testing' stamp: 'TudorGirba 8/20/2016 00:40'!
isGTExampleMethod: aCompiledMethod
	^ aCompiledMethod isGTExampleMethod! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
provider
	^ provider! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
provider: anObject
	provider := anObject! !

!GTExampleFactory methodsFor: 'private-utils' stamp: 'TudorGirba 8/20/2016 00:40'!
providerFor: aCompiledMethod
	^ provider ifNil: [ self defaultProviderFor: aCompiledMethod ]! !

!GTExampleFactory methodsFor: 'private-utils' stamp: 'TudorGirba 8/20/2016 00:40'!
providerFor: aCompiledMethod do: aBlock1
	^ self providerFor: aCompiledMethod do: aBlock1 ifNone: nil! !

!GTExampleFactory methodsFor: 'private-utils' stamp: 'TudorGirba 8/20/2016 00:40'!
providerFor: aCompiledMethod do: aBlock1 ifNone: aBlock2
	^ (self providerFor: aCompiledMethod)
		ifNotNil: aBlock1
		ifNil: aBlock2! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
source
	^ source! !

!GTExampleFactory methodsFor: 'accessing' stamp: 'TudorGirba 8/20/2016 00:39'!
source: anObject
	source := anObject! !

Object subclass: #GTExampleOrganizer
	instanceVariableNames: 'theNonMetaClassExamples theMetaClassExamples systemAnnouncements monticelloAnnouncements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Organization'!

GTExampleOrganizer class
	instanceVariableNames: 'instance'!

!GTExampleOrganizer commentStamp: 'TudorGirba 8/22/2016 14:27' prior: 0!
I know how to traverse the image to iterate over examples.
I am primarily an internal implementation utility.
!

GTExampleOrganizer class
	instanceVariableNames: 'instance'!

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:12'!
instance
	^ instance ifNil: [ instance := self basicNew initialize start ]! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 9/7/2015 21:42'!
new
	self shouldNotImplement! !

!GTExampleOrganizer class methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 15:00'!
registerInterestToSystemAnnouncement
	<systemEventRegistration>
	
	self restart! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 20:58'!
reset
	instance ifNotNil: [ instance reset ].
	instance := nil! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:43'!
restart
	self stop.
	self start.! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:43'!
start
	self instance start! !

!GTExampleOrganizer class methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 16:57'!
stop
	instance ifNotNil: [ instance stopThoroughly ].
	self reset! !

!GTExampleOrganizer methodsFor: 'private-maintenance' stamp: 'StefanReichhart 7/4/2016 17:06'!
addExamplesOfClass: aClassName for: announcement
	(Smalltalk classNamed: aClassName asString) ifNotNil: [ :class | 
		announcement addExamples: class theNonMetaClass gtExamples ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/2/2016 21:44'!
announcer
	^ SystemAnnouncer uniqueInstance weak! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 23:58'!
browserEnvironment
	| environment |
	environment := RBSelectorEnvironment new.
	self examplesDo: [ :className :selector :example |
		environment addClass: example methodClass selector: example selector ].
	^ environment! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/11/2016 15:49'!
categoryRemoved: anAnnouncement
	self withoutExceptionsDo: [ 
		self with: GTExamplesModifiedAnnouncement announcement: anAnnouncement do: [ :ann |
			self examplesDo: [ :example | ann removeExample: example ].
			self reset.
			self examplesDo: [ :example | ann addExample: example ]. ] ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/21/2016 17:34'!
classRemoved: anAnnouncement
	self withoutExceptionsDo: [ 
		self resetStubs.
		self with: GTExamplesModifiedAnnouncement announcement: anAnnouncement do: [ :ann |
			self removeExamplesOfClass: anAnnouncement classRemoved theNonMetaClass name for: ann ] ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/21/2016 17:34'!
classRenamed: anAnnouncement
	self withoutExceptionsDo: [ 
		self resetStubs.
		self with: GTExamplesModifiedAnnouncement announcement: anAnnouncement do: [ :ann |
			self removeExamplesOfClass: anAnnouncement oldName for: ann.
			self addExamplesOfClass: anAnnouncement newName for: ann ] ]! !

!GTExampleOrganizer methodsFor: 'TODO' stamp: 'StefanReichhart 7/5/2016 16:22'!
exampleAt: aCompiledMethod
	^ self exampleAt: aCompiledMethod ifAbsent: [ aCompiledMethod gtExample ]! !

!GTExampleOrganizer methodsFor: 'TODO' stamp: 'StefanReichhart 7/5/2016 16:23'!
exampleAt: aCompiledMethod ifAbsent: aBlock
	^ self exampleAtClass: aCompiledMethod methodClass selector: aCompiledMethod selector ifAbsent: aBlock! !

!GTExampleOrganizer methodsFor: 'TODO' stamp: 'StefanReichhart 7/2/2016 21:04'!
exampleAt: aCompiledMethod ifAbsentPut: aBlock
	^ self exampleAtClass: aCompiledMethod methodClass selector: aCompiledMethod selector ifAbsentPut: aBlock! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/4/2016 20:07'!
exampleAtClass: class selector: selector ifAbsent: aBlock
	^ ((class isMeta 
		ifTrue: [ theMetaClassExamples ]
		ifFalse: [ theNonMetaClassExamples ]) 
			at: class theNonMetaClass name
			ifAbsentPut: [ WeakIdentityKeyDictionary new: 100 ])
				at: selector 
				ifAbsent: aBlock! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 16:21'!
exampleAtClass: class selector: selector ifAbsentPut: aBlock
	| methodDict |
	methodDict := (class isMeta 
		ifTrue: [ theMetaClassExamples ]
		ifFalse: [ theNonMetaClassExamples ]) 
			at: class theNonMetaClass name
			ifAbsentPut: [ WeakIdentityKeyDictionary new: 100 ].
	^ methodDict 
		at: selector 
		ifAbsent: [ aBlock value ifNotNil: [ :example | methodDict at: selector put: example ] ]! !

!GTExampleOrganizer methodsFor: 'enumeration' stamp: 'StefanReichhart 7/5/2016 13:29'!
examplesCollect: aBlock
	| examples |
	examples := OrderedCollection new: 1000.
	self examplesDo: [ :class :method :example | 
		examples add: (aBlock value: example) ].
	^ examples! !

!GTExampleOrganizer methodsFor: 'enumeration' stamp: 'StefanReichhart 7/3/2016 17:01'!
examplesDetect: aBlock
	self examplesDo: [ :class :selector :example | 
		(aBlock value: example) ifTrue: [ ^ example ] ].
	^ nil! !

!GTExampleOrganizer methodsFor: 'enumeration' stamp: 'StefanReichhart 7/3/2016 17:00'!
examplesDo: aBlock
	theNonMetaClassExamples keysAndValuesDo: [ :className :methodDict |
		methodDict keysAndValuesDo: [ :selector :example | 
			aBlock value: className value: selector value: example ] ].
	theMetaClassExamples keysAndValuesDo: [ :className :methodDict |
		methodDict keysAndValuesDo: [ :selector :example | 
			aBlock value: className value: selector value: example ] ]! !

!GTExampleOrganizer methodsFor: 'enumeration' stamp: 'StefanReichhart 7/3/2016 17:02'!
examplesReject: aBlock
	^ self examplesSelect: [ :example | (aBlock value: example) not ]! !

!GTExampleOrganizer methodsFor: 'enumeration' stamp: 'StefanReichhart 7/5/2016 13:29'!
examplesSelect: aBlock
	| examples |
	examples := OrderedCollection new: 1000.
	self examplesDo: [ :class :selector :example | 
		(aBlock value: example) ifTrue: [ examples add: example ] ].
	^ examples! !

!GTExampleOrganizer methodsFor: 'enumeration' stamp: 'StefanReichhart 7/5/2016 13:29'!
examplesSelect: aBlock1 thenDo: aBlock2
	| examples |
	examples := OrderedCollection new: 1000.
	self examplesDo: [ :example |
		(aBlock2 value: example) ifTrue: [ 
			examples add: example.
			aBlock1 value: example ] ].
	^ examples! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 23:46'!
gtExamplesContained
	^ self examplesCollect: [ :each | each ]! !

!GTExampleOrganizer methodsFor: 'private-maintenance' stamp: 'StefanReichhart 7/4/2016 19:02'!
handleGTReservedMethod: aCompiledMethod for: announcement
	aCompiledMethod isGTReservedMethod ifFalse: [ ^ self ].
	self removeExamplesOfClass: aCompiledMethod methodClass theNonMetaClass name for: announcement! !

!GTExampleOrganizer methodsFor: 'initializing' stamp: 'StefanReichhart 8/23/2016 20:23'!
initialize
	super initialize.
	
	theNonMetaClassExamples := WeakIdentityKeyDictionary new: 10000.
	theMetaClassExamples := WeakIdentityKeyDictionary new: 10000.! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/4/2016 17:09'!
loadStarted: anAnnouncement
	self withoutExceptionsDo: [
		self stopSystemAnnouncements.
		self reset ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/4/2016 17:09'!
loadStopped: anAnnouncement
	self withoutExceptionsDo: [ 
		self startSystemAnnouncements.
		self reinitialize ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/11/2016 15:49'!
methodAdded: anAnnouncement
	self withoutExceptionsDo: [ 
		self with: GTExamplesModifiedAnnouncement announcement: anAnnouncement do: [ :ann |
			self handleGTReservedMethod: anAnnouncement method for: ann.
			self removeExamplesOfMethod: anAnnouncement method for: ann.
			ann addExample: anAnnouncement method gtExample ] ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/21/2016 17:34'!
methodModified: anAnnouncement
	self withoutExceptionsDo: [ 
		self resetStubs.
		self with: GTExamplesModifiedAnnouncement announcement: anAnnouncement do: [ :ann |
			self handleGTReservedMethod: anAnnouncement oldMethod for: ann.
			self handleGTReservedMethod: anAnnouncement method for: ann.
			self removeExamplesOfMethod: anAnnouncement oldMethod for: ann.
			self removeExamplesOfMethod: anAnnouncement method for: ann.
			ann addExample: anAnnouncement method gtExample ] ]! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'StefanReichhart 7/21/2016 17:34'!
methodRemoved: anAnnouncement
	self withoutExceptionsDo: [ 
		self resetStubs.
		self with: GTExamplesModifiedAnnouncement announcement: anAnnouncement do: [ :ann |
			self handleGTReservedMethod: anAnnouncement method for: ann.
			self removeExamplesOfMethod: anAnnouncement method for: ann ] ]! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 16:55'!
reinitialize
	SmalltalkImage current gtExamplesContained! !

!GTExampleOrganizer methodsFor: 'private-maintenance' stamp: 'StefanReichhart 7/4/2016 17:03'!
removeExamplesOfClass: aClassName for: announcement
	announcement removeExamples: (theNonMetaClassExamples removeKey: aClassName ifAbsent: [ nil ]).
	announcement removeExamples: (theMetaClassExamples removeKey: aClassName	ifAbsent: [ nil ])! !

!GTExampleOrganizer methodsFor: 'private-maintenance' stamp: 'StefanReichhart 7/14/2016 16:17'!
removeExamplesOfMethod: aCompiledMethod for: announcement
	self removeKey: aCompiledMethod methodClass theNonMetaClass name from: theNonMetaClassExamples thenDo: [ :methodDict |
		announcement removeExample: (methodDict removeKey: aCompiledMethod selector ifAbsent: [ nil ]) ].
	self removeKey: aCompiledMethod methodClass theNonMetaClass name from: theMetaClassExamples thenDo: [ :methodDict |
		announcement removeExample: (methodDict removeKey: aCompiledMethod selector ifAbsent: [ nil ]) ]! !

!GTExampleOrganizer methodsFor: 'private-maintenance' stamp: 'StefanReichhart 7/14/2016 16:17'!
removeKey: aKey from: aDictionary thenDo: aBlock
	aBlock value: (aDictionary removeKey: aKey ifAbsent: [ ^ nil ])! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:02'!
reset
	self initialize! !

!GTExampleOrganizer methodsFor: 'private-events' stamp: 'TudorGirba 8/20/2016 00:29'!
resetStubs
	[ GTExampleAspect allSubInstancesDo: [ :each | each resetStub ] ] 
		forkAt: 30
		named: 'GTExampleOrganizer >> #resetStubs'! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 16:55'!
restart
	self stopThoroughly.
	self start.! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:12'!
start
	self startMonticelloAnnouncements.
	self startSystemAnnouncements! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 11:48'!
startMonticelloAnnouncements
	monticelloAnnouncements == true ifTrue: [ ^ self ].
	SystemAnnouncer uniqueInstance weak
		when: MCVersionLoaderStarted send: #loadStarted: to: self;
		when: MCVersionLoaderStopped send: #loadStopped: to: self.
	monticelloAnnouncements := true! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 13:14'!
startSystemAnnouncements
	systemAnnouncements == true ifTrue: [ ^ self ].
	SystemAnnouncer uniqueInstance weak
		when: MethodAdded send: #methodAdded: to: self;
		when: MethodModified send: #methodModified: to: self;
		when: MethodRemoved send: #methodRemoved: to: self;
		when: ClassRemoved send: #classRemoved: to: self;
		when: ClassRenamed send: #classRenamed: to: self;
		when: CategoryRemoved send: #categoryRemoved: to: self.
	systemAnnouncements := true! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:12'!
stop
	self stopMonticelloAnnouncements.
	self stopSystemAnnouncements! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 13:14'!
stopMonticelloAnnouncements
	SystemAnnouncer uniqueInstance
		unsubscribe: MCVersionLoaderStarted thoroughlyFor: self;
		unsubscribe: MCVersionLoaderStopped thoroughlyFor: self.
	monticelloAnnouncements := false! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 13:14'!
stopSystemAnnouncements
	SystemAnnouncer uniqueInstance
		unsubscribe: MethodAdded thoroughlyFor: self;
		unsubscribe: MethodModified thoroughlyFor: self;
		unsubscribe: MethodRemoved thoroughlyFor: self;
		unsubscribe: ClassRemoved thoroughlyFor: self;
		unsubscribe: ClassRenamed thoroughlyFor: self;
		unsubscribe: CategoryRemoved thoroughlyFor: self.
	systemAnnouncements := false! !

!GTExampleOrganizer methodsFor: 'public' stamp: 'StefanReichhart 7/2/2016 21:12'!
stopThoroughly
	self stop.
	
	Announcer allSubInstances do: [ :each | each unsubscribeThoroughly: self ]! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 11:49'!
with: aClass announcement: announcement do: aBlock
	| wrappedAnnouncement |
	wrappedAnnouncement := aClass new
		announcement: announcement;
		yourself.
	aBlock value: wrappedAnnouncement.
	wrappedAnnouncement isEmpty ifTrue: [ ^ self ].
	SystemAnnouncer uniqueInstance announce: wrappedAnnouncement! !

!GTExampleOrganizer methodsFor: 'private' stamp: 'StefanReichhart 7/2/2016 21:14'!
withoutExceptionsDo: aBlock
	[ aBlock value ]
		on: Error
		do: [ :exception | " we should not ignore it, but try to continue " ]! !

Object subclass: #GTExampleProcessor
	instanceVariableNames: 'example context processing onProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTExampleProcessor commentStamp: 'TudorGirba 8/21/2016 15:02' prior: 0!
I am an abstract class for manipulating examples.

My subclasses can add different semantics for different use cases. For example, evaluating an example is to be treated differently from a debugging scenario, or from a  scenario to recorver static dependencies.!

GTExampleProcessor subclass: #GTExampleEvaluator
	instanceVariableNames: 'providers processed result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTExampleEvaluator commentStamp: 'TudorGirba 8/21/2016 15:04' prior: 0!
I am an example processor that evaluates the examples as if they are tests and I cache the result.!

GTExampleEvaluator subclass: #GTExampleDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTExampleDebugger commentStamp: 'TudorGirba 8/21/2016 15:08' prior: 0!
I am an example processor that evaluates the examples in a debugging scenario as if they are tests and I cache the result.
In case of an error, I do not intervene, and thus I allow the user to intervene through the debugger.!

!GTExampleDebugger methodsFor: 'private' stamp: 'StefanReichhart 7/13/2015 12:14'!
do: aBlock on: anException do: anotherBlock
	aBlock value! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'TudorGirba 8/21/2016 08:02'!
do: aBlock on: anException do: anotherBlock
	"I give a chance to my subclass to not handle the exception is needed"
	aBlock
		on: anException
		do: anotherBlock! !

!GTExampleEvaluator methodsFor: 'initializing' stamp: 'StefanReichhart 1/29/2017 15:10'!
initialize
	super initialize.
	
	processed := OrderedCollection new.
	providers := IdentityDictionary new.! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'StefanReichhart 5/13/2016 11:38'!
newResultFor: anExample
	^ GTExampleResult new 
		example: anExample;
		context: self context;
		yourself.! !

!GTExampleEvaluator methodsFor: 'primitives' stamp: 'StefanReichhart 1/29/2017 15:07'!
primitiveProcessExample: anExample withArguments: arguments
	^ (self providerFor: anExample) perform: anExample method selector withArguments: arguments! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'TudorGirba 8/21/2016 14:47'!
process: anExample withArguments: aBlock
	| currentResult arguments |
	currentResult := self newResultFor: anExample.
	arguments := nil.
	anExample hasValidDependencies " dynamic check "
		ifFalse: [ ^ self handleDependencyErrorFor: anExample ].
	self 
		do: [ 
			arguments := aBlock value. 
			currentResult returnValue: (self 
				primitiveProcessExample: anExample 
				withArguments: arguments) ]
		on: anExample signalableExceptions
		do: [ :exception | currentResult expectedError: exception ].
	processed add: currentResult.
	self
		do: [ self processAfter: anExample ]
		on: anExample signalableExceptions
		do: [ :exception | currentResult expectedError: exception ].
	anExample == self example ifTrue: [ result := currentResult ].
	anExample exceptions signaledBy: currentResult expectedError.
	^ currentResult returnValue! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'StefanReichhart 6/24/2016 11:52'!
processAfter: anExample
	anExample == self example ifFalse: [ ^ self ].
	processed reverseDo: [ :processedResult |
		self processAfter: processedResult example withResult: processedResult returnValue ]! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 15:58'!
processAfter: anExample withResult: anObject
	| provider |
	anExample after ifNil: [ ^ self ].
	provider := self providerFor: anExample after.
	anExample after method
		gtValueWithReceiver: provider 
		possibleArguments: { anObject }.
	providers removeKey: provider class! !

!GTExampleEvaluator methodsFor: 'private' stamp: 'StefanReichhart 1/29/2017 15:58'!
providerFor: anExampleOrExampleMethod
	| newProvider |
	newProvider := anExampleOrExampleMethod provider.
	^ providers at: newProvider class ifAbsentPut: [ newProvider ]! !

!GTExampleEvaluator methodsFor: 'public' stamp: 'StefanReichhart 8/23/2016 20:22'!
result
	result := self newResultFor: self example.
	self do: [ self value ] 
		on: Error
		do: [ :exception | result returnValue: nil; unexpectedError: exception ].
	^ result! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 18:01'!
basicProcess: anExample 
	^ self 
		process: anExample 
		withArguments: [ anExample dependenciesOrArguments collect: [ :each | self process: each ] ] ! !

!GTExampleProcessor methodsFor: 'testing' stamp: 'StefanReichhart 9/6/2015 17:44'!
canProcess
	[ self value ]
		on: GTExampleError
		do: [ ^ false ].
	^ true! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/28/2016 18:49'!
context
	^ context! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 3/28/2016 18:49'!
context: anObject
	^ context := anObject! !

!GTExampleProcessor methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 9/2/2015 20:58'!
defaultOnProcess
	^ [ :aProcessor :anExample | 
		aProcessor basicProcess: anExample ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:48'!
example
	^ example! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 14:48'!
example: anObject
	example := anObject! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 18:23'!
handleDependencyErrorFor: anExample
	^ (GTExampleDependencyError new
		example: anExample;
		defined: anExample arguments;
		expected: anExample methodArgumentNames;
		invalid: anExample invalidArguments;
		yourself) signal! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 7/3/2016 20:15'!
handleRecursionErrorFor: anExample
	^ (GTExampleRecursionDetected new 
		example: self example;
		resolved: processing;
		next: anExample;
		yourself) signal! !

!GTExampleProcessor methodsFor: 'initializing' stamp: 'StefanReichhart 3/28/2016 20:17'!
initialize
	super initialize.
	
	processing := IdentitySet new.
	context := GTExampleContext new! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 15:21'!
onProcess
	^ onProcess ifNil: [ onProcess := self defaultOnProcess ]! !

!GTExampleProcessor methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 15:21'!
onProcess: anObject
	onProcess := anObject! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 8/23/2015 15:23'!
process: anExample
	^ self process: anExample withoutLoopsDo: [ 
		self onProcess value: self value: anExample ]! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 9/4/2015 16:55'!
process: anExample withArguments: aBlock
	self subclassResponsibility! !

!GTExampleProcessor methodsFor: 'private' stamp: 'TudorGirba 8/21/2016 14:41'!
process: anExample withoutLoopsDo: aBlock
	| value |
	" check whether we already scheduled the given example for processing -> prevent recursion "
	value := nil.
	processing do: [ :processingExample |
		(processingExample = anExample) ifTrue: [
			^ self handleRecursionErrorFor: anExample ] ].	
	processing add: anExample. " prepare processing this example "
	context example: anExample.
	value := aBlock value. " process this example "
	processing remove: anExample. " done processing "
	^ value! !

!GTExampleProcessor methodsFor: 'public' stamp: 'StefanReichhart 3/28/2016 18:55'!
value 
	^ self withContextDo: [ self process: self example ]! !

!GTExampleProcessor methodsFor: 'private' stamp: 'StefanReichhart 3/28/2016 20:17'!
withContextDo: aBlock
	GTCurrentExampleContext use: context during: aBlock! !

GTExampleProcessor subclass: #GTExampleTraverser
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTExampleTraverser commentStamp: 'TudorGirba 8/21/2016 15:06' prior: 0!
I am an example processor that can traverse examples and execute an action on each of them.!

!GTExampleTraverser methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 15:04'!
action
	^ action! !

!GTExampleTraverser methodsFor: 'accessing' stamp: 'StefanReichhart 7/26/2015 15:04'!
action: anObject
	action := anObject! !

!GTExampleTraverser methodsFor: 'private' stamp: 'TudorGirba 8/21/2016 21:41'!
process: anExample withArguments: aBlock
	anExample hasValidDependencies
		ifFalse: [ ^ self handleDependencyErrorFor: anExample ].
	aBlock value.	
	self action ifNotNil: [ self example == anExample ifFalse: [ self action value: anExample ] ]! !

!GTExampleTraverser methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 16:46'!
reversed
	self onProcess: [ :processor :anExample | 
		self action ifNotNil: [ self example == anExample ifFalse: [ self action value: anExample ] ].
		anExample directDependents do: [ :each | processor process: each ] ]! !

Object subclass: #GTExampleResult
	instanceVariableNames: 'example context returnValue expectedError unexpectedError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTExampleResult commentStamp: 'TudorGirba 8/20/2016 00:08' prior: 0!
I represent the result of executing an example.

I keep track of the
- returnValue - the real object returned by the example method
- expectedErrors, unexpectedErrors - collections of possible errors encountered when executing the example method!

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 3/28/2016 18:54'!
context
	^ context! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 3/28/2016 18:54'!
context: anObject
	context := anObject! !

!GTExampleResult methodsFor: 'actions' stamp: 'StefanReichhart 8/25/2015 21:36'!
debug
	self isSuccess ifTrue: [ ^ self ].
	^ self example debug! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 6/28/2015 16:53'!
example
	^ example! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 6/28/2015 16:53'!
example: anObject
	example := anObject! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:46'!
expectedError
	^ expectedError! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:46'!
expectedError: anObject
	expectedError := anObject! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 7/3/2016 22:54'!
hasProblems
	^ self example hasProblems
		or: [ self isFailure
			or: [ self isError ] ]! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:11'!
isError
	^ self isSuccess not
		and: [ self isUnexpectedError
			and: [ self unexpectedError isGTExampleError ] ]! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:53'!
isExpectedError
	^ self expectedError notNil! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:11'!
isFailure
	^ self isSuccess not
		and: [ self isUnexpectedError
			and: [ self unexpectedError isGTExampleError not ] ]! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 7/6/2016 13:30'!
isSuccess
	^ self unexpectedError isNil
		and: [ self example isValid ]! !

!GTExampleResult methodsFor: 'testing' stamp: 'StefanReichhart 8/23/2015 13:54'!
isUnexpectedError
	^ self unexpectedError notNil! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 11:59'!
returnValue
	^ returnValue! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/2/2015 11:59'!
returnValue: anObject
	returnValue := anObject! !

!GTExampleResult methodsFor: 'actions' stamp: 'StefanReichhart 8/25/2015 21:36'!
run
	^ self example run! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:46'!
unexpectedError
	^ unexpectedError! !

!GTExampleResult methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:47'!
unexpectedError: anObject
	unexpectedError := anObject! !

!Object class methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 3/28/2016 18:53'!
gtExampleContext
	^ GTCurrentExampleContext value! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 16:00'!
asGTExampleSubject
	^ GTExampleInstanceSubject fromObject: self! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 3/28/2016 18:52'!
gtExampleContext
	^ self class gtExampleContext! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 12:23'!
gtExampleSubstrings
	^ {  }! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 9/6/2015 16:32'!
gtExamples
	^ self class gtExamples! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/2/2016 20:31'!
gtExamplesContained
	^ self gtExamples! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/2/2016 20:50'!
gtExamplesFactory
	^ self class gtExamplesFactory! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/2/2016 19:36'!
gtExamplesSubjects
	^ {  }! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/3/2016 21:58'!
isGTExample
	^ false! !

!Object methodsFor: '*GT-Examples-Exceptions' stamp: 'StefanReichhart 7/11/2016 13:08'!
isGTExampleError
	^ false! !

!Object methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/3/2016 13:33'!
isGTExampleMethod
	^ false! !

!WeakSubscriptionBuilder methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/3/2016 22:18'!
unsubscribe: anAnnouncementClass thoroughlyFor: aSubscriber
	announcer unsubscribe: anAnnouncementClass thoroughlyFor: aSubscriber! !

!WeakSubscriptionBuilder methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/5/2016 11:40'!
unsubscribeThoroughly: aSubscriber
	announcer unsubscribeThoroughly: aSubscriber! !

!SmalltalkImage class methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/4/2016 19:44'!
gtExamplesFactory
	^ super gtExamplesFactory
		provider: SmalltalkImage current;
		yourself! !

!SmalltalkImage methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/22/2016 20:25'!
gtExamplesContained
	| examples |
	examples := OrderedCollection new.
	self allClassesAndTraitsDo: [ :class |
		class gtExamplesFactory examplesDo: [ :example | 
			examples add: example ] ].
	^ examples! !

Notification subclass: #GTCurrentExampleContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTCurrentExampleContext commentStamp: 'TudorGirba 8/22/2016 14:59' prior: 0!
I model a dynamic variable to keep track of the example that is being processed right now. I am particurly useful to allow after methods to utilize information from this context.!

!GTCurrentExampleContext class methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/28/2016 18:45'!
defaultValue
	^ nil! !

!GTCurrentExampleContext class methodsFor: 'evaluating' stamp: 'StefanReichhart 3/28/2016 18:45'!
use: anObject during: aBlock
	^ aBlock 
		on: self 
		do: [ :notification | notification resume: anObject ]! !

!GTCurrentExampleContext class methodsFor: 'evaluating' stamp: 'StefanReichhart 3/28/2016 18:45'!
value
	^ self signal! !

!GTCurrentExampleContext methodsFor: 'accessing-defaults' stamp: 'StefanReichhart 3/28/2016 18:44'!
defaultAction
	^ self class defaultValue! !

!String methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 15:43'!
asGTExampleSubject
	^ GTExampleTextSubject fromString: self! !

!String methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 12:22'!
gtExampleSubstrings
	^ ((self substrings: ' .,;') 
		collect: [ :each | each trimBoth ])
		reject: [ :each | each isEmptyOrNil ]! !

HDReport subclass: #GTExamplesHDReport
	instanceVariableNames: 'suite stream suitePosition suiteTime suiteFailures suiteErrors progressFile examples executionTime examplesPosition examplesErrors examplesFailures title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Testing'!

!GTExamplesHDReport commentStamp: 'TudorGirba 5/11/2017 15:17' prior: 0!
I am a report that once executed produces an XML result that can be integrated in Hudson/Jenkins in order to display run/failing examples as tests.!

!GTExamplesHDReport class methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:27'!
runPackage: aString
	^ self new 
		initializeExamples: (RPackage organizer packageNamed: aString) gtExamplesContained 
		entitled: aString;
		run! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/11/2017 18:03'!
begin
	progressFile nextPutAll: 'running suite: ';
		nextPutAll: 'Examples' ; crlf; flush.
		
	stream := StandardFileStream forceNewFileNamed: 'Examples' , '-Test.xml'.
	stream := MultiByteFileStream newFrom: stream.
	stream nextPutAll: '<?xml version="1.0" encoding="UTF-8"?>'; lf.
	stream nextPutAll: '<testsuite name="'; nextPutAll: (self encode: 'Examples'); 
		nextPutAll: '" tests="'; print: examples size; nextPutAll: '">'.
	
	"Now this is ugly. We want to update the time and the number of failures and errors, but still at the same time stream a valid XML. So remember this position and add some whitespace, that we can fill later."
	examplesPosition := stream position - 1.
	stream nextPutAll: (String new: 100 withAll: $ ); lf! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/13/2017 07:32'!
beginExample: anExample runBlock: aBlock
	| time |
	progressFile nextPutAll: 'starting example: '.
	anExample printOn: progressFile.
	progressFile nextPutAll: ' ... '; flush.
	time := aBlock timeToRun.
	stream tab; 
		nextPutAll: '<testcase classname="'; 
		nextPutAll: (self encode: (anExample methodClass category copyReplaceAll: '-' with: '.')); 
		nextPut: $.; nextPutAll: (self encode: anExample methodClass name); 
		nextPutAll: '" name="'; nextPutAll: (self encode: anExample selector); 
		nextPutAll: '" time="'; print: (time asMilliSeconds / 1000.0); 
		nextPutAll: '">'; lf
	
! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/11/2017 10:27'!
done
	"just close the file"
	[ progressFile close ] on: Error do: []! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:29'!
end		
	stream tab; nextPutAll: '<system-out><!![CDATA[]]></system-out>'; lf.
	stream tab; nextPutAll: '<system-err><!![CDATA[]]></system-err>'; lf.
	stream nextPutAll: '</testsuite>'.
	
	stream position: examplesPosition.
	stream 
"		nextPutAll: ' failures=""'; print: examplesFailures; "
		nextPutAll: '" errors="'; print: examplesErrors; 
		nextPutAll: '" time="'; print: executionTime asMilliSeconds / 1000.0; 
		nextPutAll: '">'.
	stream close.
	
	progressFile 
		nextPutAll: 'finished running suite: ';
		nextPutAll: 'Examples';
		close! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/11/2017 18:03'!
endExample
	stream tab; nextPutAll: '</testcase>'; lf.
	progressFile nextPutAll: 'finished' ; crlf; flush.
! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:24'!
exampleErrors
	^ suiteErrors! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:24'!
exampleFailures
	^ suiteFailures! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/11/2017 18:03'!
examplePassing 
	^ self suiteTotal - self suiteFailures - self suiteErrors! !

!GTExamplesHDReport methodsFor: 'initialization' stamp: 'TudorGirba 5/11/2017 18:03'!
examples: aCollection
	examples := aCollection! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:24'!
examplesErrors
	^ suiteErrors! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/13/2017 07:24'!
examplesFailures
	^ suiteFailures! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/11/2017 18:03'!
examplesPassing 
	^ self suiteTotal - self suiteFailures - self suiteErrors! !

!GTExamplesHDReport methodsFor: 'accessing' stamp: 'TudorGirba 5/11/2017 18:03'!
examplesTotal
	^ suite 
		ifNotNil: [ suite tests size ]
		ifNil: [ 0 ]! !

!GTExamplesHDReport methodsFor: 'testing' stamp: 'TudorGirba 5/11/2017 18:03'!
hasErrors 
	^ examplesErrors ~= 0! !

!GTExamplesHDReport methodsFor: 'testing' stamp: 'TudorGirba 5/13/2017 07:07'!
hasFailures 
	^ examplesFailures ~= 0! !

!GTExamplesHDReport methodsFor: 'initialization' stamp: 'TudorGirba 5/13/2017 07:24'!
initialize
	super initialize.
	suiteTime := 0 asDuration.
	suitePosition := suiteFailures := examplesErrors := 0.
	progressFile := StandardFileStream forceNewFileNamed: 'progress.log'
	! !

!GTExamplesHDReport methodsFor: 'initialization' stamp: 'TudorGirba 5/13/2017 07:18'!
initializeExamples: aCollection entitled: aString
	examples := aCollection.
	title := aString! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/11/2017 18:03'!
run
	Author uniqueInstance
		ifUnknownAuthorUse: 'hudson'
		during: [ [ 
			self setUp.
			executionTime := [ self runAll ]
				timeToRun ]
					ensure: [ self tearDown ] ]! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:34'!
runAll
	CurrentExecutionEnvironment runTestsBy: [ 
		examples do: [ :each | self runExample: each ]
	]! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:36'!
runExample: anExample
	| error stack  |
	self
		beginExample: anExample
		runBlock: [ 
			[ anExample debug ]
				on: Halt, Error, AssertionFailure
				do: [ :err |
					error := err.
					self
						serializeError: error
						of: anExample.
					stack := self
						stackTraceString: err
						of: anExample ] ].
	self
		writeError: error
		andStack: stack
		for: anExample.
	self endExample! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:30'!
serializeError: error of: anExample
	"We got an error from a test, let's serialize it so we can properly debug it later on..."
	| context testCaseMethodContext |
	
	context := error signalerContext.
	testCaseMethodContext := context findContextSuchThat: [ :ctx| 
		ctx receiver == anExample and: [ ctx methodSelector == #performTest ]].
	context := context copyTo: testCaseMethodContext.
	
	[ FuelOutStackDebugAction
		serializeTestFailureContext: context sender 		
		toFileNamed: anExample methodClass name asString,'-', anExample selector, '.fuel' ] 
	on: Error 
	do: [:err| "simply continue..." ]

! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:33'!
setUp
	progressFile nextPutAll: 'running suite: ';
		nextPutAll: title ; crlf; flush.
		
	stream := StandardFileStream forceNewFileNamed: title , '-Test.xml'.
	stream := MultiByteFileStream newFrom: stream.
	stream nextPutAll: '<?xml version="1.0" encoding="UTF-8"?>'; lf.
	stream nextPutAll: '<testsuite name="'; nextPutAll: (self encode: title); 
		nextPutAll: '" tests="'; print: examples size; nextPutAll: '">'.
	
	"Now this is ugly. We want to update the time and the number of failures and errors, but still at the same time stream a valid XML. So remember this position and add some whitespace, that we can fill later."
	examplesPosition := stream position - 1.
	stream nextPutAll: (String new: 100 withAll: $ ); lf.! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/11/2017 10:27'!
stackTraceString: err of: aTestCase
	^ String streamContents: [ :str | 
		| context |
		context := err signalerContext.
		[ context isNil or: [ context receiver == aTestCase and: [ context methodSelector == #runCase ] ] ] whileFalse: [
			str print: context; lf.
			context := context sender ] ] ! !

!GTExamplesHDReport methodsFor: 'running' stamp: 'TudorGirba 5/13/2017 07:35'!
tearDown
	stream tab; nextPutAll: '<system-out><!![CDATA[]]></system-out>'; lf.
	stream tab; nextPutAll: '<system-err><!![CDATA[]]></system-err>'; lf.
	stream nextPutAll: '</testsuite>'.
	
	stream position: examplesPosition.
	stream 
		nextPutAll: ' failures="'; print: examplesFailures; 
		nextPutAll: '" errors="'; print: examplesErrors; 
		nextPutAll: '" time="'; print: executionTime asMilliSeconds / 1000.0; 
		nextPutAll: '">'.
	stream close.
	
	progressFile 
		nextPutAll: 'finished running suite: ';
		nextPutAll: title;
		close! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/11/2017 18:03'!
writeError: anError andStack: aString for: aTestCase
	"XML tag is now open"
	anError ifNotNil: [
		(anError isKindOf: AssertionFailure)
			ifTrue: [ self writeFailure: anError stack: aString ]
			ifFalse: [ self writeError: anError stack: aString ] ]! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/11/2017 18:03'!
writeError: error stack: stack
	examplesErrors := examplesErrors + 1.
	stream tab; tab; nextPutAll: '<error type="'.
	self writeException: error stack: stack.
	stream nextPutAll: '</error>'; lf! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/11/2017 10:27'!
writeException: error stack: stack.

	stream 
		nextPutAll: (self encode: error class name); 
		nextPutAll: '" message="'; nextPutAll: (self encode: (error messageText ifNil: [ error description ])); 
		nextPutAll: '">'; 
		nextPutAll: (self encode: stack).! !

!GTExamplesHDReport methodsFor: 'private' stamp: 'TudorGirba 5/13/2017 07:29'!
writeFailure: error stack: stack
	examplesFailures := examplesFailures + 1.
	stream tab; tab; nextPutAll: '<failure type="'.
	self writeException: error stack: stack.  
	stream	nextPutAll: '</failure>'; lf! !

!Context class methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/6/2016 15:07'!
gtExamplesFactory
	^ super gtExamplesFactory
		provider: self;
		yourself! !

IdentityDictionary subclass: #GTExampleContext
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Runtime'!

!GTExampleContext commentStamp: 'TudorGirba 8/22/2016 15:02' prior: 0!
I am a utility that holds custom contextual information about the current example.!

!GTExampleContext methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 13:20'!
example
	^ example! !

!GTExampleContext methodsFor: 'accessing' stamp: 'StefanReichhart 7/11/2016 13:20'!
example: anObject
	example := anObject! !

!Announcer methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/3/2016 22:18'!
unsubscribe: anAnnouncementClass thoroughlyFor: aSubscriber
	^ registry protected: [
		registry subscriptions removeAllSuchThat: [ :subscription | 
			subscription subscriber class == aSubscriber class " class !!!!!! "
			 and: [ subscription announcementClass == anAnnouncementClass ] ] ]
! !

!Announcer methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 2/26/2016 10:41'!
unsubscribeThoroughly: aSubscriber
	^ registry protected: [
		registry subscriptions removeAllSuchThat: [ :subscription | 
			subscription subscriber class == aSubscriber class " class !!!!!! " ] ]
! !

!Magnitude class methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/6/2016 14:57'!
gtExamplesFactory
	^ super gtExamplesFactory
		provider: self;
		yourself! !

TestCase subclass: #GTExampleTestCase
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Testing'!

!GTExampleTestCase commentStamp: 'TudorGirba 8/21/2016 07:41' prior: 0!
I am an abstract bridge between examples and SUnit.

Subclasses can specify the packages from which I should collect the examples and run them as tests.!

!GTExampleTestCase class methodsFor: 'testing' stamp: 'StefanReichhart 9/26/2015 11:24'!
isAbstract
	^ self name = #GTExampleTestCase! !

!GTExampleTestCase methodsFor: 'private' stamp: 'StefanReichhart 7/3/2016 22:12'!
package: package matchesPackagePattern: packageName
	^ package packageName = packageName
		or: [ (packageName match: package packageName) 
			or: [ [ package packageName matchesRegexIgnoringCase: packageName ] 
						on: Error 
						do: [ false ] ] ]! !

!GTExampleTestCase methodsFor: 'configuration' stamp: 'StefanReichhart 9/26/2015 10:17'!
packageNames
	^ {  }! !

!GTExampleTestCase methodsFor: 'private' stamp: 'StefanReichhart 7/3/2016 22:11'!
packages: aCollection
	| packages |
	packages := OrderedCollection new.
	RPackageOrganizer default packages do: [ :package |
		aCollection do: [ :packageName |
			(self package: package matchesPackagePattern: packageName) ifTrue: [ 
				packages add: package ] ] ].
	^ packages! !

!GTExampleTestCase methodsFor: 'private' stamp: 'StefanReichhart 9/26/2015 11:11'!
run: aResult
	result := aResult.
	[ super run: aResult ] ensure: [ result := nil ]! !

!GTExampleTestCase methodsFor: 'private' stamp: 'StefanReichhart 9/26/2015 11:12'!
runCase
	result ifNil: [ result := self classForTestResult new " fake for debug runner " ].
	super runCase. ! !

!GTExampleTestCase methodsFor: 'private' stamp: 'StefanReichhart 6/21/2016 15:56'!
runExample: example
	" this is not the testing tool we have in mind, but a temporary solution to integrate examples into the currently existing testing tools "
	| exampleResult |
	example ignoreTest ifTrue: [ ^ self ].
	self shouldnt: [ exampleResult := example run ] raise: Error.
	exampleResult isError 
		ifTrue: [ ^ self classForTestResult signalErrorWith: exampleResult gtDisplayString  ].
	exampleResult isFailure 
		ifTrue: [ ^ self classForTestResult signalFailureWith: exampleResult gtDisplayString  ] ! !

!GTExampleTestCase methodsFor: 'private' stamp: 'StefanReichhart 6/21/2016 15:58'!
runExampleContainers: aCollection
	| allExamples |
	(allExamples := aCollection gather: [ :container | container gtExamplesContained ])
		do: [ :example | self runExample: example ]
		displayingProgress: 'Running ' , allExamples size asString , ' Examples'! !

!GTExampleTestCase methodsFor: 'tests' stamp: 'StefanReichhart 9/26/2015 11:17'!
testExamples
	" default testcase "
	self runExampleContainers: (self packages: self packageNames)! !

RBBlockLintRule subclass: #GTExampleNotDefinedRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Testing'!

!GTExampleNotDefinedRule commentStamp: 'AndreiChis 1/22/2016 16:20' prior: 0!
Every class that defines a custom extension for GTSpotter or GTInspector should define also, at least, a GTExample.!

!GTExampleNotDefinedRule class methodsFor: 'testing' stamp: 'AndreiChis 1/22/2016 15:46'!
checksClass
	^ true! !

!GTExampleNotDefinedRule class methodsFor: 'accessing' stamp: 'AndreiChis 1/22/2016 16:02'!
uniqueIdentifierName
	"This number should be unique and should change only when the rule completely change semantics"
	
	^'GTExampleNotDefinedRule'! !

!GTExampleNotDefinedRule methodsFor: 'running' stamp: 'AndreiChis 1/22/2016 15:56'!
basicCheck: aClass 
	^ (self containsCustomExtension: aClass) 
		and: [ (self containsGTExample: aClass) not ]! !

!GTExampleNotDefinedRule methodsFor: 'private' stamp: 'StefanReichhart 3/18/2017 15:21'!
check: aClass forCritiquesDo: aCriticBlock ifNone: alternativeBlock 
	Smalltalk at: #ReMissingMethodCritic ifPresent: [ :class |
		(self basicCheck: aClass)
			ifTrue:  [ aCriticBlock cull: (class
							for: aClass
							by: self
							class: aClass class
							selector: #gtExample) beShouldBeImplemented ]
			ifFalse: alternativeBlock ]! !

!GTExampleNotDefinedRule methodsFor: 'running' stamp: 'AndreiChis 1/22/2016 16:10'!
checkClass: aClass 
	(self basicCheck: aClass) ifTrue: [
		result
			addClass: aClass ]! !

!GTExampleNotDefinedRule methodsFor: 'running' stamp: 'StefanReichhart 3/18/2017 15:12'!
containsCustomExtension: aClass

	^ aClass methods anySatisfy: [:aMethod | 
		aMethod pragmas anySatisfy: [ :aPragma |
			aPragma keyword = #gtInspectorPresentationOrder: or: [
				aPragma keyword = #spotterOrder: ]]]! !

!GTExampleNotDefinedRule methodsFor: 'running' stamp: 'AndreiChis 1/22/2016 15:59'!
containsGTExample: aClass

	^ aClass class methods anySatisfy: [:aMethod | 
			aMethod pragmas 
				anySatisfy: [ :pragma | pragma isGTExamplePragma ]]! !

!GTExampleNotDefinedRule methodsFor: 'accessing' stamp: 'AndreiChis 1/22/2016 15:46'!
group
	^ 'Design Flaws'! !

!GTExampleNotDefinedRule methodsFor: 'accessing' stamp: 'AndreiChis 1/22/2016 16:00'!
name
	^ 'Class defines a custom GT extension but no example'! !

!GTExampleNotDefinedRule methodsFor: 'accessing' stamp: 'AndreiChis 1/22/2016 15:46'!
resultClass
	^ RBClassEnvironment! !

!GTExampleNotDefinedRule methodsFor: 'accessing' stamp: 'AndreiChis 1/22/2016 15:46'!
severity
	^ #information! !

!RBBrowserEnvironment methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/6/2016 21:17'!
gtExamplesContained
	| examples |
	examples := OrderedCollection new.
	self methodsDo: [ :each | 
		each isGTExampleMethod ifTrue: [ 
			each gtExample ifNotNil: [ :example | 
				examples add: example ] ] ].
	^ examples! !

!RPackage methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 16:02'!
asGTExampleSubject
	^ GTExamplePackageSubject fromPackage: self! !

!RPackage methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/28/2016 17:15'!
gtExamplesContained
	| examples |
	examples := OrderedCollection new.
	self methods do: [ :method |
		examples addAll: method gtExamples ].
	" temporary HACK since all examples are packaged into GT-Examples-Examples due to alpha state >>> "
	self classesAndMetaClasses do: [ :class | 
		(class organization protocolNamed: '*GT-Examples-Examples') ifNotNil: [ :protocol |
			protocol methods do: [ :selector |
				examples addAll: (class >> selector) gtExamples ] ] ].
	" <<< "
	^ examples! !

!Symbol methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 15:47'!
asGTExampleSubject
	^ GTExampleKeywordSubject fromSymbol: self! !

Announcement subclass: #GTExamplesModifiedAnnouncement
	instanceVariableNames: 'announcement added removed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Announcements'!

!GTExamplesModifiedAnnouncement commentStamp: 'TudorGirba 8/21/2016 07:38' prior: 0!
I am an announcement announcing that an example method was modified.

I am particularly useful for allowing tools to refresh their state if something happens with an example.!

!GTExamplesModifiedAnnouncement methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 19:25'!
addExample: anExample
	anExample ifNil: [ ^ self ].
	added add: anExample! !

!GTExamplesModifiedAnnouncement methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 19:37'!
addExamples: aCollection
	aCollection ifNil: [ ^ self ].
	aCollection do: [ :value | self addExample: value ]! !

!GTExamplesModifiedAnnouncement methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 19:25'!
announcement
	^ announcement! !

!GTExamplesModifiedAnnouncement methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 19:25'!
announcement: anObject
	announcement := anObject! !

!GTExamplesModifiedAnnouncement methodsFor: 'initializing' stamp: 'StefanReichhart 7/3/2016 19:31'!
initialize
	super initialize.
	
	added := OrderedCollection new: 100.
	removed := OrderedCollection new: 100.! !

!GTExamplesModifiedAnnouncement methodsFor: 'testing' stamp: 'StefanReichhart 7/5/2016 11:15'!
isEmpty
	^ added isEmptyOrNil 
		or: [ removed isEmptyOrNil ]! !

!GTExamplesModifiedAnnouncement methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 19:25'!
removeExample: anExample
	anExample ifNil: [ ^ self ].
	removed add: anExample! !

!GTExamplesModifiedAnnouncement methodsFor: 'public' stamp: 'StefanReichhart 7/3/2016 19:37'!
removeExamples: aCollection
	aCollection ifNil: [ ^ self ].
	aCollection do: [ :value | self removeExample: value ]! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 16:10'!
asGTExampleSubject
	^ GTExampleMethodSubject fromClass: self methodClass selector: self selector! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/3/2016 13:37'!
gtExample
	self gtExamplesFactory exampleMethod: self do: [ :example | ^ example ].
	^ nil! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 5/29/2016 12:22'!
gtExampleValue
	^ self gtExample returnValue! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/4/2016 15:18'!
gtExamples
	^ self gtExample 
		ifNotNil: [ :example | { example } ]
		ifNil: [ {  } ]! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/6/2016 15:00'!
gtExamplesFactory
	^ self methodClass gtExamplesFactory! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/14/2016 16:16'!
gtValueWithReceiver: aReceiver possibleArguments: anArray 
	^ anArray size = self numArgs 
		ifTrue: [ self valueWithReceiver: aReceiver arguments: anArray  ]
		ifFalse: [ self valueWithReceiver: aReceiver arguments: (anArray copyFrom: 1 to: self numArgs) ]! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/3/2016 13:32'!
isGTExampleMethod
	^ self pragmas anySatisfy: [ :each | each isGTExamplePragma ]! !

!CompiledMethod methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/4/2016 18:58'!
isGTReservedMethod
	^ #( gtExamplesSubjects gtExamplesFactory gtExample gtExamples ) 
			anySatisfy: [ :selector | selector = self selector ]! !

!TClassDescription methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 1/29/2017 13:20'!
asGTExampleSubject
	^ GTExampleClassSubject new 
		theClassName: self name;
		theClass: self;
		meta: self isMeta;
		yourself! !

!TClassDescription methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/2/2016 20:13'!
gtExamples
	^ self gtExamplesFactory gtExamplesContained! !

!TClassDescription methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/2/2016 18:58'!
gtExamplesFactory
	^ GTExampleFactory new
		source: self;
		yourself! !

!TClassDescription methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 7/15/2016 13:11'!
gtExamplesSubjects
	^ { self }! !

!Text methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 15:46'!
asGTExampleSubject
	^ GTExampleTextSubject fromText: self! !

Error subclass: #GTExampleError
	instanceVariableNames: 'example signaledException'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleError commentStamp: 'TudorGirba 8/21/2016 07:45' prior: 0!
I am an abstract error induced by a signaledException related to a specific example.

My subclasses define the specific error.!

GTExampleError subclass: #GTExampleDependencyError
	instanceVariableNames: 'expected defined invalid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleDependencyError commentStamp: 'TudorGirba 8/21/2016 14:51' prior: 0!
I represent a static error induced by a wrong declaration of an example. There are two cases when I am triggered:
	- when the amount of method arguments are not matching the amount of dependency definitions 
	- when the example dependencies do not exist !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 7/14/2016 18:24'!
defined
	^ defined! !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 7/14/2016 18:24'!
defined: anObject
	defined := anObject! !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 7/14/2016 18:18'!
expected
	^ expected! !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 7/14/2016 18:18'!
expected: anObject
	expected := anObject! !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 7/14/2016 18:22'!
invalid
	^ invalid! !

!GTExampleDependencyError methodsFor: 'accessing' stamp: 'StefanReichhart 7/14/2016 18:22'!
invalid: anObject
	invalid := anObject! !

!GTExampleError methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:01'!
example
	^ example! !

!GTExampleError methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:01'!
example: anObject
	example := anObject! !

!GTExampleError methodsFor: 'testing' stamp: 'StefanReichhart 7/11/2016 13:08'!
isGTExampleError
	^ true! !

!GTExampleError methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 12:18'!
signaledException
	^ signaledException! !

!GTExampleError methodsFor: 'accessing' stamp: 'StefanReichhart 7/3/2016 12:18'!
signaledException: anObject
	signaledException := anObject! !

GTExampleError subclass: #GTExamplePragmaError
	instanceVariableNames: 'pragma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExamplePragmaError commentStamp: 'TudorGirba 8/21/2016 14:51' prior: 0!
I am an abstract error related to the way the pragmas are used within an example method.!

GTExamplePragmaError subclass: #GTExampleDeclaredClassMissing
	instanceVariableNames: 'classNamed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleDeclaredClassMissing commentStamp: 'TudorGirba 8/21/2016 15:10' prior: 0!
I am an error that occurs when an example declares a dependency to a method belonging to a class that does not exist in the image.!

!GTExampleDeclaredClassMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:54'!
classNamed
	^ classNamed! !

!GTExampleDeclaredClassMissing methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:54'!
classNamed: anObject
	classNamed := anObject! !

GTExamplePragmaError subclass: #GTExampleDeprecationDetected
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleDeprecationDetected commentStamp: 'StefanReichhart 2/19/2017 16:32' prior: 0!
I am an error that occurs when an example encounters a deprecation warning during instanciation.!

!GTExamplePragmaError methodsFor: 'accessing' stamp: 'StefanReichhart 7/2/2016 19:31'!
pragma
	^ pragma! !

!GTExamplePragmaError methodsFor: 'accessing' stamp: 'StefanReichhart 7/2/2016 19:31'!
pragma: anObject
	pragma := anObject! !

GTExamplePragmaError subclass: #GTExampleSubjectError
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleSubjectError commentStamp: 'TudorGirba 8/21/2016 15:10' prior: 0!
I am an error that occurs when an example declares a subject that does not exist in the image.!

!GTExampleSubjectError methodsFor: 'accessing' stamp: 'StefanReichhart 7/2/2016 19:53'!
subject
	^ subject! !

!GTExampleSubjectError methodsFor: 'accessing' stamp: 'StefanReichhart 7/2/2016 19:53'!
subject: anObject
	subject := anObject! !

GTExampleError subclass: #GTExampleRecursionDetected
	instanceVariableNames: 'resolved next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleRecursionDetected commentStamp: 'TudorGirba 8/21/2016 14:55' prior: 0!
I represent an error that occurs when we have cycles in static example dependencies. The cycles can be either direct or indirect. For example,  these configurations induces an error:
- a depends-on b, b depends-on a
- a depends-on b, b depends-on c, c depends-on a
	!

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
next
	^ next! !

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
next: anObject
	next := anObject! !

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
resolved
	^ resolved! !

!GTExampleRecursionDetected methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 12:00'!
resolved: anObject
	resolved := anObject! !

Error subclass: #GTExampleExpectedExceptionNotRaised
	instanceVariableNames: 'expectedError exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleExpectedExceptionNotRaised commentStamp: 'TudorGirba 8/21/2016 15:26' prior: 0!
I am an error that occurs when an example declares that a certain exception is expected to be raised, and during the evaluation that exception is not raised.!

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:46'!
exception
	^ exception! !

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2015 11:46'!
exception: anObject
	exception := anObject! !

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:48'!
expectedError
	^ expectedError! !

!GTExampleExpectedExceptionNotRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:48'!
expectedError: anObject
	expectedError := anObject! !

Error subclass: #GTExampleUnexpectedExceptionRaised
	instanceVariableNames: 'unexpectedError'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Exceptions'!

!GTExampleUnexpectedExceptionRaised commentStamp: 'TudorGirba 8/21/2016 15:27' prior: 0!
I am an error that occurs when the evaluation of an example raises an exception without that exception being declared as being expected.!

!GTExampleUnexpectedExceptionRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:49'!
unexpectedError
	^ unexpectedError! !

!GTExampleUnexpectedExceptionRaised methodsFor: 'accessing' stamp: 'StefanReichhart 8/23/2015 13:49'!
unexpectedError: anObject
	unexpectedError := anObject! !

CustomHelp subclass: #GTExampleHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-Help'!

!GTExampleHelp commentStamp: 'TudorGirba 8/19/2016 23:55' prior: 0!
I hold the help for the examples engine.!

!GTExampleHelp class methodsFor: 'accessing' stamp: 'StefanReichhart 7/21/2016 18:09'!
bookName 
	^'GT Examples'! !

!GTExampleHelp class methodsFor: 'accessing' stamp: 'StefanReichhart 7/21/2016 18:09'!
key
	^ self name! !

!GTExampleHelp class methodsFor: 'accessing' stamp: 'StefanReichhart 7/21/2016 18:10'!
pages 
	^ #( pragmas )! !

!GTExampleHelp class methodsFor: 'documentation' stamp: 'StefanReichhart 7/21/2016 18:20'!
pragmas
	^ HelpTopic 
		title: 'Pragmas'
		contents: self pragmasContents
		yourself! !

!GTExampleHelp class methodsFor: 'documentation' stamp: 'StefanReichhart 7/21/2016 18:25'!
pragmasContents
	^ String streamContents: [ :stream |
		((Pragma allNamed: #gtExamplePragma in: GTExample) 
			sort: [ :a :b | a method selector <= b method selector ]) 
			do: [ :each |
				stream nextPutAll: '<'.
				stream nextPutAll: (each method sourceCode copyUpTo: Character cr).
				stream nextPutAll: '>'.
				stream cr.
				each method pragmas do: [ :pragma | 
					pragma == each ifFalse: [ 
						stream nextPutAll: (String streamContents: [ :argStream |
							pragma arguments 
								do: [ :arg | argStream nextPutAll: arg asString ]
								separatedBy: [ argStream cr ] ]) ] ].
				stream cr; cr ] ]! !

!SequenceableCollection methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 12:23'!
gtExampleSubstrings
	^ (self gather: [ :each | each gtExampleSubstrings ])
		reject: [ :each | each isEmptyOrNil ]! !

!RGMethodDefinition methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 8/13/2016 16:09'!
asGTExampleSubject
	^ GTExampleMethodSubject fromClass: self realClass selector: self selector! !

!Pragma methodsFor: '*GT-Examples-Core' stamp: 'StefanReichhart 9/9/2015 19:54'!
isGTExamplePragma
	<toBeDeprecated: #gtExample:>
	^ self keyword = #gtExample
		or: [ self keyword = #gtExample: ]! !
